// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package jit

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	model "LAPP_GAAS_GFrame_BACKEND/models/jit"
)

/******************************************************************************
 *
 * @Description              : ShipOrder的字段元数据
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
var ShipOrder_PlantNr = grmi.NewField("PlantNr", "[JIT_ShipOrder].PlantNr", "plantnr", grmi.TypeInt)
var ShipOrder_ShipOrderId = grmi.NewField("ShipOrderId", "[JIT_ShipOrder].ShipOrderId", "shiporderid", grmi.TypeString)
var ShipOrder_Descr = grmi.NewField("Descr", "[JIT_ShipOrder].Descr", "descr", grmi.TypeString)
var ShipOrder_ShipTemplateId = grmi.NewField("ShipTemplateId", "[JIT_ShipOrder].ShipTemplateId", "shiptemplateid", grmi.TypeString)
var ShipOrder_ProjectId = grmi.NewField("ProjectId", "[JIT_ShipOrder].ProjectId", "projectid", grmi.TypeString)
var ShipOrder_StartSequence = grmi.NewField("StartSequence", "[JIT_ShipOrder].StartSequence", "startsequence", grmi.TypeInt)
var ShipOrder_EndSequence = grmi.NewField("EndSequence", "[JIT_ShipOrder].EndSequence", "endsequence", grmi.TypeInt)
var ShipOrder_Status = grmi.NewField("Status", "[JIT_ShipOrder].Status", "status", grmi.TypeInt)
var ShipOrder_ShipType = grmi.NewField("ShipType", "[JIT_ShipOrder].ShipType", "shiptype", grmi.TypeString)
var ShipOrder_OrderInfo = grmi.NewField("OrderInfo", "[JIT_ShipOrder].OrderInfo", "orderinfo", grmi.TypeString)
var ShipOrder_PrinterId = grmi.NewField("PrinterId", "[JIT_ShipOrder].PrinterId", "printerid", grmi.TypeString)
var ShipOrder_TemplateFile = grmi.NewField("TemplateFile", "[JIT_ShipOrder].TemplateFile", "templatefile", grmi.TypeString)
var ShipOrder_PlanQty = grmi.NewField("PlanQty", "[JIT_ShipOrder].PlanQty", "planqty", grmi.TypeInt)
var ShipOrder_ActualQty = grmi.NewField("ActualQty", "[JIT_ShipOrder].ActualQty", "actualqty", grmi.TypeInt)
var ShipOrder_OpenTime = grmi.NewField("OpenTime", "[JIT_ShipOrder].OpenTime", "opentime", grmi.TypeDateTime)
var ShipOrder_CloseTime = grmi.NewField("CloseTime", "[JIT_ShipOrder].CloseTime", "closetime", grmi.TypeDateTime)
var ShipOrder_Operator = grmi.NewField("Operator", "[JIT_ShipOrder].Operator", "operator", grmi.TypeString)
var ShipOrder_SupplierCode = grmi.NewField("SupplierCode", "[JIT_ShipOrder].SupplierCode", "suppliercode", grmi.TypeString)
var ShipOrder_PurchaseOrderId = grmi.NewField("PurchaseOrderId", "[JIT_ShipOrder].PurchaseOrderId", "purchaseorderid", grmi.TypeString)
var ShipOrder_DeliverDate = grmi.NewField("DeliverDate", "[JIT_ShipOrder].DeliverDate", "deliverdate", grmi.TypeDate)
var ShipOrder_ShipDate = grmi.NewField("ShipDate", "[JIT_ShipOrder].ShipDate", "shipdate", grmi.TypeDate)
var ShipOrder_CtrlPara1 = grmi.NewField("CtrlPara1", "[JIT_ShipOrder].CtrlPara1", "ctrlpara1", grmi.TypeInt)
var ShipOrder_CtrlPara2 = grmi.NewField("CtrlPara2", "[JIT_ShipOrder].CtrlPara2", "ctrlpara2", grmi.TypeInt)
var ShipOrder_CtrlPara3 = grmi.NewField("CtrlPara3", "[JIT_ShipOrder].CtrlPara3", "ctrlpara3", grmi.TypeInt)
var ShipOrder_CtrlPara4 = grmi.NewField("CtrlPara4", "[JIT_ShipOrder].CtrlPara4", "ctrlpara4", grmi.TypeInt)
var ShipOrder_CtrlStr1 = grmi.NewField("CtrlStr1", "[JIT_ShipOrder].CtrlStr1", "ctrlstr1", grmi.TypeString)
var ShipOrder_CtrlStr2 = grmi.NewField("CtrlStr2", "[JIT_ShipOrder].CtrlStr2", "ctrlstr2", grmi.TypeString)
var ShipOrder_CtrlStr3 = grmi.NewField("CtrlStr3", "[JIT_ShipOrder].CtrlStr3", "ctrlstr3", grmi.TypeString)
var ShipOrder_CtrlStr4 = grmi.NewField("CtrlStr4", "[JIT_ShipOrder].CtrlStr4", "ctrlstr4", grmi.TypeString)
var ShipOrder_CtrlTime1 = grmi.NewField("CtrlTime1", "[JIT_ShipOrder].CtrlTime1", "ctrltime1", grmi.TypeDateTime)
var ShipOrder_CtrlTime2 = grmi.NewField("CtrlTime2", "[JIT_ShipOrder].CtrlTime2", "ctrltime2", grmi.TypeDateTime)
var ShipOrder_CtrlTime3 = grmi.NewField("CtrlTime3", "[JIT_ShipOrder].CtrlTime3", "ctrltime3", grmi.TypeDateTime)
var ShipOrder_CtrlTime4 = grmi.NewField("CtrlTime4", "[JIT_ShipOrder].CtrlTime4", "ctrltime4", grmi.TypeDateTime)
var ShipOrder_LastModify = grmi.NewField("LastModify", "[JIT_ShipOrder].LastModify", "lastmodify", grmi.TypeDateTime)
var ShipOrder_LastUser = grmi.NewField("LastUser", "[JIT_ShipOrder].LastUser", "lastuser", grmi.TypeString)
var ShipOrder_CreateTime = grmi.NewField("CreateTime", "[JIT_ShipOrder].CreateTime", "createtime", grmi.TypeDateTime)

/******************************************************************************
 *
 * @Description              : ShipOrder的元数据
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
var ShipOrder = grmi.NewEntity(
	"JIT_ShipOrder",
	func() interface{} { return &model.ShipOrder{} },
	map[string]grmi.Field{
		ShipOrder_PlantNr.Name:         ShipOrder_PlantNr,
		ShipOrder_ShipOrderId.Name:     ShipOrder_ShipOrderId,
		ShipOrder_Descr.Name:           ShipOrder_Descr,
		ShipOrder_ShipTemplateId.Name:  ShipOrder_ShipTemplateId,
		ShipOrder_ProjectId.Name:       ShipOrder_ProjectId,
		ShipOrder_StartSequence.Name:   ShipOrder_StartSequence,
		ShipOrder_EndSequence.Name:     ShipOrder_EndSequence,
		ShipOrder_Status.Name:          ShipOrder_Status,
		ShipOrder_ShipType.Name:        ShipOrder_ShipType,
		ShipOrder_OrderInfo.Name:       ShipOrder_OrderInfo,
		ShipOrder_PrinterId.Name:       ShipOrder_PrinterId,
		ShipOrder_TemplateFile.Name:    ShipOrder_TemplateFile,
		ShipOrder_PlanQty.Name:         ShipOrder_PlanQty,
		ShipOrder_ActualQty.Name:       ShipOrder_ActualQty,
		ShipOrder_OpenTime.Name:        ShipOrder_OpenTime,
		ShipOrder_CloseTime.Name:       ShipOrder_CloseTime,
		ShipOrder_Operator.Name:        ShipOrder_Operator,
		ShipOrder_SupplierCode.Name:    ShipOrder_SupplierCode,
		ShipOrder_PurchaseOrderId.Name: ShipOrder_PurchaseOrderId,
		ShipOrder_DeliverDate.Name:     ShipOrder_DeliverDate,
		ShipOrder_ShipDate.Name:        ShipOrder_ShipDate,
		ShipOrder_CtrlPara1.Name:       ShipOrder_CtrlPara1,
		ShipOrder_CtrlPara2.Name:       ShipOrder_CtrlPara2,
		ShipOrder_CtrlPara3.Name:       ShipOrder_CtrlPara3,
		ShipOrder_CtrlPara4.Name:       ShipOrder_CtrlPara4,
		ShipOrder_CtrlStr1.Name:        ShipOrder_CtrlStr1,
		ShipOrder_CtrlStr2.Name:        ShipOrder_CtrlStr2,
		ShipOrder_CtrlStr3.Name:        ShipOrder_CtrlStr3,
		ShipOrder_CtrlStr4.Name:        ShipOrder_CtrlStr4,
		ShipOrder_CtrlTime1.Name:       ShipOrder_CtrlTime1,
		ShipOrder_CtrlTime2.Name:       ShipOrder_CtrlTime2,
		ShipOrder_CtrlTime3.Name:       ShipOrder_CtrlTime3,
		ShipOrder_CtrlTime4.Name:       ShipOrder_CtrlTime4,
		ShipOrder_LastModify.Name:      ShipOrder_LastModify,
		ShipOrder_LastUser.Name:        ShipOrder_LastUser,
		ShipOrder_CreateTime.Name:      ShipOrder_CreateTime,
	},
	[]string{"PlantNr"},
	[]string{"Descr", "ShipTemplateId", "ProjectId", "StartSequence", "EndSequence", "Status", "ShipType", "OrderInfo", "PrinterId", "TemplateFile", "PlanQty", "ActualQty", "OpenTime", "CloseTime", "Operator", "SupplierCode", "PurchaseOrderId", "DeliverDate", "ShipDate", "CtrlPara1", "CtrlPara2", "CtrlPara3", "CtrlPara4", "CtrlStr1", "CtrlStr2", "CtrlStr3", "CtrlStr4", "CtrlTime1", "CtrlTime2", "CtrlTime3", "CtrlTime4", "LastUser"})
