// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package jit

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ShipOrder
 *-----------------------------------------------------------------------------
 *
 * @Description              : ShipOrder的实体映射
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
type ShipOrder struct {
	PlantNr          int                `xorm:"pk int 'PlantNr'" json:"JIT_ShipOrder-PlantNr"`
	ShipOrderId      string             `xorm:"pk nvarchar(40) 'ShipOrderId'" json:"JIT_ShipOrder-ShipOrderId"`
	Descr            string             `xorm:"nvarchar(100) 'Descr' not null" json:"JIT_ShipOrder-Descr"`
	ShipTemplateId   string             `xorm:"nvarchar(40) 'ShipTemplateId' not null" json:"JIT_ShipOrder-ShipTemplateId"`
	ProjectId        string             `xorm:"nvarchar(40) 'ProjectId' not null" json:"JIT_ShipOrder-ProjectId"`
	StartSequence    int                `xorm:"int 'StartSequence' not null" json:"JIT_ShipOrder-StartSequence"`
	EndSequence      int                `xorm:"int 'EndSequence' not null" json:"JIT_ShipOrder-EndSequence"`
	Status           int                `xorm:"int 'Status' not null" json:"JIT_ShipOrder-Status"`
	ShipType         string             `xorm:"nvarchar(40) 'ShipType' not null" json:"JIT_ShipOrder-ShipType"`
	OrderInfo        string             `xorm:"nvarchar(40) 'OrderInfo' not null" json:"JIT_ShipOrder-OrderInfo"`
	PrinterId        string             `xorm:"nvarchar(40) 'PrinterId' not null" json:"JIT_ShipOrder-PrinterId"`
	TemplateFile     string             `xorm:"nvarchar(40) 'TemplateFile' not null" json:"JIT_ShipOrder-TemplateFile"`
	PlanQty          int                `xorm:"int 'PlanQty' not null" json:"JIT_ShipOrder-PlanQty"`
	ActualQty        int                `xorm:"int 'ActualQty' not null" json:"JIT_ShipOrder-ActualQty"`
	OpenTime         grmi.DateTime      `xorm:"datetime 'OpenTime'" json:"JIT_ShipOrder-OpenTime"`
	CloseTime        grmi.DateTime      `xorm:"datetime 'CloseTime'" json:"JIT_ShipOrder-CloseTime"`
	Operator         string             `xorm:"nvarchar(40) 'Operator' not null" json:"JIT_ShipOrder-Operator"`
	SupplierCode     string             `xorm:"nvarchar(40) 'SupplierCode' not null" json:"JIT_ShipOrder-SupplierCode"`
	PurchaseOrderId  string             `xorm:"nvarchar(40) 'PurchaseOrderId' not null" json:"JIT_ShipOrder-PurchaseOrderId"`
	DeliverDate      grmi.Date          `xorm:"date 'DeliverDate' not null" json:"JIT_ShipOrder-DeliverDate"`
	ShipDate         grmi.Date          `xorm:"date 'ShipDate' not null" json:"JIT_ShipOrder-ShipDate"`
	CtrlPara1        int                `xorm:"int 'CtrlPara1' not null" json:"JIT_ShipOrder-CtrlPara1"`
	CtrlPara2        int                `xorm:"int 'CtrlPara2' not null" json:"JIT_ShipOrder-CtrlPara2"`
	CtrlPara3        int                `xorm:"int 'CtrlPara3' not null" json:"JIT_ShipOrder-CtrlPara3"`
	CtrlPara4        int                `xorm:"int 'CtrlPara4' not null" json:"JIT_ShipOrder-CtrlPara4"`
	CtrlStr1         string             `xorm:"nvarchar(255) 'CtrlStr1' not null" json:"JIT_ShipOrder-CtrlStr1"`
	CtrlStr2         string             `xorm:"nvarchar(255) 'CtrlStr2' not null" json:"JIT_ShipOrder-CtrlStr2"`
	CtrlStr3         string             `xorm:"nvarchar(255) 'CtrlStr3' not null" json:"JIT_ShipOrder-CtrlStr3"`
	CtrlStr4         string             `xorm:"nvarchar(255) 'CtrlStr4' not null" json:"JIT_ShipOrder-CtrlStr4"`
	CtrlTime1        grmi.DateTime      `xorm:"datetime 'CtrlTime1'" json:"JIT_ShipOrder-CtrlTime1"`
	CtrlTime2        grmi.DateTime      `xorm:"datetime 'CtrlTime2'" json:"JIT_ShipOrder-CtrlTime2"`
	CtrlTime3        grmi.DateTime      `xorm:"datetime 'CtrlTime3'" json:"JIT_ShipOrder-CtrlTime3"`
	CtrlTime4        grmi.DateTime      `xorm:"datetime 'CtrlTime4'" json:"JIT_ShipOrder-CtrlTime4"`
	LastModify       grmi.DateTime      `xorm:"datetime 'LastModify' not null updated" json:"JIT_ShipOrder-LastModify"`
	LastUser         string             `xorm:"nvarchar(20) 'LastUser' not null" json:"JIT_ShipOrder-LastUser"`
	CreateTime       grmi.DateTime      `xorm:"datetime 'CreateTime' not null created" json:"JIT_ShipOrder-CreateTime"`
	ShipOrderItemlst []ShipOrderItemlst `xorm:"-" json:"JIT_ShipOrder-ShipOrderItemlst"`
}

/******************************************************************************
 *
 * @Function Name            : GetKey
 *-----------------------------------------------------------------------------
 *
 * @Description              : 获取实体的主键
 *
 * @Return Value             : 实体的主键
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
func (self *ShipOrder) GetKey() core.PK {
	return core.PK{self.PlantNr, self.ShipOrderId}
}
