// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package jit

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ShipOrderDatalst
 *-----------------------------------------------------------------------------
 *
 * @Description              : ShipOrderDatalst的实体映射
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
type ShipOrderDatalst struct {
	PlantNr        int           `xorm:"pk int 'PlantNr'" json:"JIT_ShipOrderDatalst-PlantNr"`
	ShipOrderId    string        `xorm:"pk nvarchar(40) 'ShipOrderId'" json:"JIT_ShipOrderDatalst-ShipOrderId"`
	Pos            int           `xorm:"pk int 'Pos'" json:"JIT_ShipOrderDatalst-Pos"`
	ShipObjId      string        `xorm:"nvarchar(40) 'ShipObjId' not null" json:"JIT_ShipOrderDatalst-ShipObjId"`
	ShipObjBarcode string        `xorm:"nvarchar(255) 'ShipObjBarcode' not null" json:"JIT_ShipOrderDatalst-ShipObjBarcode"`
	ItemId         string        `xorm:"nvarchar(40) 'ItemId' not null" json:"JIT_ShipOrderDatalst-ItemId"`
	Status         int           `xorm:"int 'Status' not null" json:"JIT_ShipOrderDatalst-Status"`
	PlanQty        int           `xorm:"int 'PlanQty' not null" json:"JIT_ShipOrderDatalst-PlanQty"`
	ActualQty      int           `xorm:"int 'ActualQty' not null" json:"JIT_ShipOrderDatalst-ActualQty"`
	CtrlPara1      int           `xorm:"int 'CtrlPara1' not null" json:"JIT_ShipOrderDatalst-CtrlPara1"`
	CtrlPara2      int           `xorm:"int 'CtrlPara2' not null" json:"JIT_ShipOrderDatalst-CtrlPara2"`
	CtrlPara3      int           `xorm:"int 'CtrlPara3' not null" json:"JIT_ShipOrderDatalst-CtrlPara3"`
	CtrlPara4      int           `xorm:"int 'CtrlPara4' not null" json:"JIT_ShipOrderDatalst-CtrlPara4"`
	CtrlStr1       string        `xorm:"nvarchar(255) 'CtrlStr1' not null" json:"JIT_ShipOrderDatalst-CtrlStr1"`
	CtrlStr2       string        `xorm:"nvarchar(255) 'CtrlStr2' not null" json:"JIT_ShipOrderDatalst-CtrlStr2"`
	CtrlStr3       string        `xorm:"nvarchar(255) 'CtrlStr3' not null" json:"JIT_ShipOrderDatalst-CtrlStr3"`
	CtrlStr4       string        `xorm:"nvarchar(255) 'CtrlStr4' not null" json:"JIT_ShipOrderDatalst-CtrlStr4"`
	CtrlTime1      grmi.DateTime `xorm:"datetime 'CtrlTime1'" json:"JIT_ShipOrderDatalst-CtrlTime1"`
	CtrlTime2      grmi.DateTime `xorm:"datetime 'CtrlTime2'" json:"JIT_ShipOrderDatalst-CtrlTime2"`
	CtrlTime3      grmi.DateTime `xorm:"datetime 'CtrlTime3'" json:"JIT_ShipOrderDatalst-CtrlTime3"`
	CtrlTime4      grmi.DateTime `xorm:"datetime 'CtrlTime4'" json:"JIT_ShipOrderDatalst-CtrlTime4"`
	LastModify     grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"JIT_ShipOrderDatalst-LastModify"`
	LastUser       string        `xorm:"nvarchar(20) 'LastUser' not null" json:"JIT_ShipOrderDatalst-LastUser"`
	CreateTime     grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"JIT_ShipOrderDatalst-CreateTime"`
}

/******************************************************************************
 *
 * @Function Name            : GetKey
 *-----------------------------------------------------------------------------
 *
 * @Description              : 获取实体的主键
 *
 * @Return Value             : 实体的主键
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
func (self *ShipOrderDatalst) GetKey() core.PK {
	return core.PK{self.PlantNr, self.ShipOrderId, self.Pos}
}
