// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package jit

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ShipOrderItemlst
 *-----------------------------------------------------------------------------
 *
 * @Description              : ShipOrderItemlst的实体映射
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
type ShipOrderItemlst struct {
	PlantNr            int           `xorm:"pk int 'PlantNr'" json:"JIT_ShipOrderItemlst-PlantNr"`
	ShipOrderId        string        `xorm:"pk nvarchar(40) 'ShipOrderId'" json:"JIT_ShipOrderItemlst-ShipOrderId"`
	ItemId             string        `xorm:"pk nvarchar(40) 'ItemId'" json:"JIT_ShipOrderItemlst-ItemId"`
	ItemType           string        `xorm:"nvarchar(40) 'ItemType' not null" json:"JIT_ShipOrderItemlst-ItemType"`
	Pos                int           `xorm:"int 'Pos' not null" json:"JIT_ShipOrderItemlst-Pos"`
	ShipValidateToggle bool          `xorm:"bit 'ShipValidateToggle' not null" json:"JIT_ShipOrderItemlst-ShipValidateToggle"`
	Descr              string        `xorm:"nvarchar(100) 'Descr' not null" json:"JIT_ShipOrderItemlst-Descr"`
	ProjectId          string        `xorm:"nvarchar(40) 'ProjectId' not null" json:"JIT_ShipOrderItemlst-ProjectId"`
	ArtCode            string        `xorm:"nvarchar(100) 'ArtCode' not null" json:"JIT_ShipOrderItemlst-ArtCode"`
	Spec               string        `xorm:"nvarchar(100) 'Spec' not null" json:"JIT_ShipOrderItemlst-Spec"`
	Status             int           `xorm:"int 'Status' not null" json:"JIT_ShipOrderItemlst-Status"`
	Sequence           int           `xorm:"int 'Sequence' not null" json:"JIT_ShipOrderItemlst-Sequence"`
	SlotId             string        `xorm:"nvarchar(40) 'SlotId' not null" json:"JIT_ShipOrderItemlst-SlotId"`
	Carset             string        `xorm:"nvarchar(100) 'Carset' not null" json:"JIT_ShipOrderItemlst-Carset"`
	PlanQty            int           `xorm:"int 'PlanQty' not null" json:"JIT_ShipOrderItemlst-PlanQty"`
	ActualQty          int           `xorm:"int 'ActualQty' not null" json:"JIT_ShipOrderItemlst-ActualQty"`
	OrderQty           int           `xorm:"int 'OrderQty' not null" json:"JIT_ShipOrderItemlst-OrderQty"`
	GoodQty            int           `xorm:"int 'GoodQty' not null" json:"JIT_ShipOrderItemlst-GoodQty"`
	ScrapQty           int           `xorm:"int 'ScrapQty' not null" json:"JIT_ShipOrderItemlst-ScrapQty"`
	RecievedQty        int           `xorm:"int 'RecievedQty' not null" json:"JIT_ShipOrderItemlst-RecievedQty"`
	SupplierPartId     string        `xorm:"nvarchar(40) 'SupplierPartId' not null" json:"JIT_ShipOrderItemlst-SupplierPartId"`
	CustomerPartId     string        `xorm:"nvarchar(40) 'CustomerPartId' not null" json:"JIT_ShipOrderItemlst-CustomerPartId"`
	PartId             string        `xorm:"nvarchar(40) 'PartId' not null" json:"JIT_ShipOrderItemlst-PartId"`
	PartName           string        `xorm:"nvarchar(100) 'PartName' not null" json:"JIT_ShipOrderItemlst-PartName"`
	FillQty            int           `xorm:"int 'FillQty' not null" json:"JIT_ShipOrderItemlst-FillQty"`
	ShortShipToggle    bool          `xorm:"bit 'ShortShipToggle' not null" json:"JIT_ShipOrderItemlst-ShortShipToggle"`
	ShortShipQty       int           `xorm:"int 'ShortShipQty' not null" json:"JIT_ShipOrderItemlst-ShortShipQty"`
	ShortBy            string        `xorm:"nvarchar(40) 'ShortBy' not null" json:"JIT_ShipOrderItemlst-ShortBy"`
	ShortTime          grmi.DateTime `xorm:"datetime 'ShortTime'" json:"JIT_ShipOrderItemlst-ShortTime"`
	CtrlPara1          int           `xorm:"int 'CtrlPara1' not null" json:"JIT_ShipOrderItemlst-CtrlPara1"`
	CtrlPara2          int           `xorm:"int 'CtrlPara2' not null" json:"JIT_ShipOrderItemlst-CtrlPara2"`
	CtrlPara3          int           `xorm:"int 'CtrlPara3' not null" json:"JIT_ShipOrderItemlst-CtrlPara3"`
	CtrlPara4          int           `xorm:"int 'CtrlPara4' not null" json:"JIT_ShipOrderItemlst-CtrlPara4"`
	CtrlStr1           string        `xorm:"nvarchar(255) 'CtrlStr1' not null" json:"JIT_ShipOrderItemlst-CtrlStr1"`
	CtrlStr2           string        `xorm:"nvarchar(255) 'CtrlStr2' not null" json:"JIT_ShipOrderItemlst-CtrlStr2"`
	CtrlStr3           string        `xorm:"nvarchar(255) 'CtrlStr3' not null" json:"JIT_ShipOrderItemlst-CtrlStr3"`
	CtrlStr4           string        `xorm:"nvarchar(255) 'CtrlStr4' not null" json:"JIT_ShipOrderItemlst-CtrlStr4"`
	CtrlTime1          grmi.DateTime `xorm:"datetime 'CtrlTime1'" json:"JIT_ShipOrderItemlst-CtrlTime1"`
	CtrlTime2          grmi.DateTime `xorm:"datetime 'CtrlTime2'" json:"JIT_ShipOrderItemlst-CtrlTime2"`
	CtrlTime3          grmi.DateTime `xorm:"datetime 'CtrlTime3'" json:"JIT_ShipOrderItemlst-CtrlTime3"`
	CtrlTime4          grmi.DateTime `xorm:"datetime 'CtrlTime4'" json:"JIT_ShipOrderItemlst-CtrlTime4"`
	LastModify         grmi.DateTime `xorm:"datetime 'LastModify' not null updated" json:"JIT_ShipOrderItemlst-LastModify"`
	LastUser           string        `xorm:"nvarchar(20) 'LastUser' not null" json:"JIT_ShipOrderItemlst-LastUser"`
	CreateTime         grmi.DateTime `xorm:"datetime 'CreateTime' not null created" json:"JIT_ShipOrderItemlst-CreateTime"`
}

/******************************************************************************
 *
 * @Function Name            : GetKey
 *-----------------------------------------------------------------------------
 *
 * @Description              : 获取实体的主键
 *
 * @Return Value             : 实体的主键
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
func (self *ShipOrderItemlst) GetKey() core.PK {
	return core.PK{self.PlantNr, self.ShipOrderId, self.ItemId}
}
