// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package jit

import (
	model "LAPP_GAAS_GFrame_BACKEND/models/jit"
	"LAPP_GAAS_GFrame_BACKEND/services/jit/implments"
	"LAPP_GAAS_GFrame_BACKEND/web/models"
)

/******************************************************************************
 *
 * @Interface Name           : ShipOrderItemlstService
 *-----------------------------------------------------------------------------
 *
 * @Description              : ShipOrderItemlst的服务接口
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
type ShipOrderItemlstService interface {
	/******************************************************************************
	 *
	 * @Function Name            : InsertOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 插入一条ShipOrderItemlst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要插入的ShipOrderItemlst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	InsertOne(*models.Usertab, *model.ShipOrderItemlst) error
	/******************************************************************************
	 *
	 * @Function Name            : DeleteOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 删除指定键的ShipOrderItemlst
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	DeleteOne(*models.Usertab, string, string) error
	/******************************************************************************
	 *
	 * @Function Name            : SelectOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 查找指定键的ShipOrderItemlst
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Return Value             : 查找到的ShipOrderItemlst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	SelectOne(*models.Usertab, string, string) (*model.ShipOrderItemlst, error)
	/******************************************************************************
	 *
	 * @Function Name            : UpdateOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 修改一条ShipOrderItemlst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要修改的ShipOrderItemlst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	UpdateOne(*models.Usertab, *model.ShipOrderItemlst) error
	/******************************************************************************
	 *
	 * @Function Name            : Insert
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 插入多条ShipOrderItemlst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要插入的ShipOrderItemlst列表
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	Insert(*models.Usertab, *[]model.ShipOrderItemlst) error
	/******************************************************************************
	 *
	 * @Function Name            : Delete
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 删除多条ShipOrderItemlst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要删除的ShipOrderItemlst列表
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	Delete(*models.Usertab, *[]model.ShipOrderItemlst) error
	/******************************************************************************
	 *
	 * @Function Name            : SelectAndPaging
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 查询ShipOrderItemlst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 查询参数
	 *
	 * @Return Value             : 查询结果
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	Select(*models.Usertab, map[string]string) ([]model.ShipOrderItemlst, error)
	/******************************************************************************
	 *
	 * @Function Name            : Update
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 修改多条ShipOrderItemlst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要修改的ShipOrderItemlst列表
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-08-13 13:42:26
	 *
	 ******************************************************************************/
	Update(*models.Usertab, *[]model.ShipOrderItemlst) error
}

/******************************************************************************
 *
 * @Function Name            : NewShipOrderItemlstService
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ShipOrderItemlstService
 *
 * @Return Value             : ShipOrderItemlstService实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
func NewShipOrderItemlstService() ShipOrderItemlstService {
	return implments.NewShipOrderItemlstServiceImplement()
}
