// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	dal "LAPP_GAAS_GFrame_BACKEND/dao/jit"
	"LAPP_GAAS_GFrame_BACKEND/db"
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/jit"
	model "LAPP_GAAS_GFrame_BACKEND/models/jit"
	"LAPP_GAAS_GFrame_BACKEND/web/models"
)

/******************************************************************************
 *
 * @Description              : ShipOrderDatalst的默认查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
var DefaultConditionOfShipOrderDatalst = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.ShipOrderDatalst_ShipOrderId.UrlParameterName:    grmi.NewConditionItem(meta.ShipOrderDatalst_ShipOrderId, grmi.Equal, true),
		meta.ShipOrderDatalst_Pos.UrlParameterName:            grmi.NewConditionItem(meta.ShipOrderDatalst_Pos, grmi.Equal, true),
		meta.ShipOrderDatalst_ShipObjId.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_ShipObjId, grmi.Equal, false),
		meta.ShipOrderDatalst_ShipObjBarcode.UrlParameterName: grmi.NewConditionItem(meta.ShipOrderDatalst_ShipObjBarcode, grmi.Equal, false),
		meta.ShipOrderDatalst_Status.UrlParameterName:         grmi.NewConditionItem(meta.ShipOrderDatalst_Status, grmi.Equal, false),
		meta.ShipOrderDatalst_PlanQty.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderDatalst_PlanQty, grmi.Equal, false),
		meta.ShipOrderDatalst_ActualQty.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_ActualQty, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlPara1.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlPara1, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlPara2.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlPara2, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlPara3.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlPara3, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlPara4.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlPara4, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlStr1.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlStr1, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlStr2.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlStr2, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlStr3.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlStr3, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlStr4.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlStr4, grmi.Equal, false),
		meta.ShipOrderDatalst_CtrlTime1.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlTime1, grmi.Approximate, false),
		meta.ShipOrderDatalst_CtrlTime2.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlTime2, grmi.Approximate, false),
		meta.ShipOrderDatalst_CtrlTime3.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlTime3, grmi.Approximate, false),
		meta.ShipOrderDatalst_CtrlTime4.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderDatalst_CtrlTime4, grmi.Approximate, false),
		meta.ShipOrderDatalst_LastModify.UrlParameterName:     grmi.NewConditionItem(meta.ShipOrderDatalst_LastModify, grmi.Approximate, false),
		meta.ShipOrderDatalst_LastUser.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderDatalst_LastUser, grmi.Equal, false),
		meta.ShipOrderDatalst_CreateTime.UrlParameterName:     grmi.NewConditionItem(meta.ShipOrderDatalst_CreateTime, grmi.Approximate, false),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : ShipOrderDatalst的默认分页查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
var DefaultConditionOfShipOrderDatalstAndPaging = grmi.NewCondition(
	DefaultConditionOfShipOrderDatalst.Items,
	grmi.NewPaging(),
)

/******************************************************************************
 *
 * @Struct Name              : ShipOrderDatalstServiceImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ShipOrderDatalst的服务实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
type ShipOrderDatalstServiceImplement struct {
}

/******************************************************************************
 *
 * @Function Name            : NewShipOrderDatalstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ShipOrderDatalstDAOImplement实例
 *
 * @Return Value             : ShipOrderDatalstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
func NewShipOrderDatalstServiceImplement() *ShipOrderDatalstServiceImplement {
	return &ShipOrderDatalstServiceImplement{}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.InsertOne
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) InsertOne(user *models.Usertab, entity *model.ShipOrderDatalst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "InsertOneShipOrderDatalst", "插入一个ShipOrderDatalst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ShipOrderId, entity.Pos)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.DeleteOne
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) DeleteOne(user *models.Usertab, shipOrderId string, pos int) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "DeleteOneShipOrderDatalst", "删除一个ShipOrderDatalst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(shipOrderId, pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(shipOrderId, pos)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.SelectOne
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) SelectOne(user *models.Usertab, shipOrderId string, pos int) (*model.ShipOrderDatalst, error) {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "SelectOneShipOrderDatalst", "查询一个ShipOrderDatalst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(shipOrderId, pos)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.UpdateOne
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) UpdateOne(user *models.Usertab, entity *model.ShipOrderDatalst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "UpdateOneShipOrderDatalst", "修改一个ShipOrderDatalst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ShipOrderId, entity.Pos)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.Insert
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) Insert(user *models.Usertab, entities *[]model.ShipOrderDatalst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "InsertShipOrderDatalst", "插入多个ShipOrderDatalst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.ShipOrderId, entity.Pos)
		if err != nil {
			return err
		}
		if record != nil {
			return grmi.NewBusinessError("已经存在相同主键的记录!")
		}
	}

	err := dao.Insert(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.Delete
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) Delete(user *models.Usertab, entities *[]model.ShipOrderDatalst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "DeleteShipOrderDatalst", "删除多个ShipOrderDatalst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.ShipOrderId, entity.Pos)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Delete(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.Select
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) Select(user *models.Usertab, urlParameters map[string]string) ([]model.ShipOrderDatalst, error) {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "SelectShipOrderDatalst", "查询ShipOrderDatalst")

	condition := DefaultConditionOfShipOrderDatalstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)
	//if condition.Fill(urlParameters) {
	//	result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
	//	if err != nil {
	//		return nil, err
	//	}
	//	return result, nil
	//} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	//}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderDatalstService.Update
 *
 ******************************************************************************/
func (impl *ShipOrderDatalstServiceImplement) Update(user *models.Usertab, entities *[]model.ShipOrderDatalst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderDatalst.service.impl.go", "UpdateShipOrderDatalst", "修改多个ShipOrderDatalst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderDatalstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.ShipOrderId, entity.Pos)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Update(entities)
	if err != nil {
		return err
	}
	return nil
}
