// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	dal "LAPP_GAAS_GFrame_BACKEND/dao/jit"
	"LAPP_GAAS_GFrame_BACKEND/db"
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/jit"
	model "LAPP_GAAS_GFrame_BACKEND/models/jit"
	"LAPP_GAAS_GFrame_BACKEND/web/models"
)

/******************************************************************************
 *
 * @Description              : ShipOrderItemlst的默认查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
var DefaultConditionOfShipOrderItemlst = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.ShipOrderItemlst_ShipOrderId.UrlParameterName:     grmi.NewConditionItem(meta.ShipOrderItemlst_ShipOrderId, grmi.Equal, true),
		meta.ShipOrderItemlst_ItemId.UrlParameterName:          grmi.NewConditionItem(meta.ShipOrderItemlst_ItemId, grmi.Equal, true),
		meta.ShipOrderItemlst_ItemType.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderItemlst_ItemType, grmi.Equal, false),
		meta.ShipOrderItemlst_Pos.UrlParameterName:             grmi.NewConditionItem(meta.ShipOrderItemlst_Pos, grmi.Equal, false),
		meta.ShipOrderItemlst_Descr.UrlParameterName:           grmi.NewConditionItem(meta.ShipOrderItemlst_Descr, grmi.Equal, false),
		meta.ShipOrderItemlst_ProjectId.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_ProjectId, grmi.Equal, false),
		meta.ShipOrderItemlst_ArtCode.UrlParameterName:         grmi.NewConditionItem(meta.ShipOrderItemlst_ArtCode, grmi.Equal, false),
		meta.ShipOrderItemlst_Spec.UrlParameterName:            grmi.NewConditionItem(meta.ShipOrderItemlst_Spec, grmi.Equal, false),
		meta.ShipOrderItemlst_Status.UrlParameterName:          grmi.NewConditionItem(meta.ShipOrderItemlst_Status, grmi.Equal, false),
		meta.ShipOrderItemlst_Sequence.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderItemlst_Sequence, grmi.Equal, false),
		meta.ShipOrderItemlst_SlotId.UrlParameterName:          grmi.NewConditionItem(meta.ShipOrderItemlst_SlotId, grmi.Equal, false),
		meta.ShipOrderItemlst_Carset.UrlParameterName:          grmi.NewConditionItem(meta.ShipOrderItemlst_Carset, grmi.Equal, false),
		meta.ShipOrderItemlst_PlanQty.UrlParameterName:         grmi.NewConditionItem(meta.ShipOrderItemlst_PlanQty, grmi.Equal, false),
		meta.ShipOrderItemlst_ActualQty.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_ActualQty, grmi.Equal, false),
		meta.ShipOrderItemlst_FillQty.UrlParameterName:         grmi.NewConditionItem(meta.ShipOrderItemlst_FillQty, grmi.Equal, false),
		meta.ShipOrderItemlst_ShortShipToggle.UrlParameterName: grmi.NewConditionItem(meta.ShipOrderItemlst_ShortShipToggle, grmi.Equal, false),
		meta.ShipOrderItemlst_ShortShipQty.UrlParameterName:    grmi.NewConditionItem(meta.ShipOrderItemlst_ShortShipQty, grmi.Equal, false),
		meta.ShipOrderItemlst_ShortBy.UrlParameterName:         grmi.NewConditionItem(meta.ShipOrderItemlst_ShortBy, grmi.Equal, false),
		meta.ShipOrderItemlst_ShortTime.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_ShortTime, grmi.Approximate, false),
		meta.ShipOrderItemlst_CtrlPara1.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlPara1, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlPara2.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlPara2, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlPara3.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlPara3, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlPara4.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlPara4, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlStr1.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlStr1, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlStr2.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlStr2, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlStr3.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlStr3, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlStr4.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlStr4, grmi.Equal, false),
		meta.ShipOrderItemlst_CtrlTime1.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlTime1, grmi.Approximate, false),
		meta.ShipOrderItemlst_CtrlTime2.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlTime2, grmi.Approximate, false),
		meta.ShipOrderItemlst_CtrlTime3.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlTime3, grmi.Approximate, false),
		meta.ShipOrderItemlst_CtrlTime4.UrlParameterName:       grmi.NewConditionItem(meta.ShipOrderItemlst_CtrlTime4, grmi.Approximate, false),
		meta.ShipOrderItemlst_LastModify.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderItemlst_LastModify, grmi.Approximate, false),
		meta.ShipOrderItemlst_LastUser.UrlParameterName:        grmi.NewConditionItem(meta.ShipOrderItemlst_LastUser, grmi.Equal, false),
		meta.ShipOrderItemlst_CreateTime.UrlParameterName:      grmi.NewConditionItem(meta.ShipOrderItemlst_CreateTime, grmi.Approximate, false),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : ShipOrderItemlst的默认分页查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
var DefaultConditionOfShipOrderItemlstAndPaging = grmi.NewCondition(
	DefaultConditionOfShipOrderItemlst.Items,
	grmi.NewPaging(),
)

/******************************************************************************
 *
 * @Struct Name              : ShipOrderItemlstServiceImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ShipOrderItemlst的服务实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
type ShipOrderItemlstServiceImplement struct {
}

/******************************************************************************
 *
 * @Function Name            : NewShipOrderItemlstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ShipOrderItemlstDAOImplement实例
 *
 * @Return Value             : ShipOrderItemlstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-08-13 13:42:26
 *
 ******************************************************************************/
func NewShipOrderItemlstServiceImplement() *ShipOrderItemlstServiceImplement {
	return &ShipOrderItemlstServiceImplement{}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.InsertOne
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) InsertOne(user *models.Usertab, entity *model.ShipOrderItemlst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "InsertOneShipOrderItemlst", "插入一个ShipOrderItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ShipOrderId, entity.ItemId)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.DeleteOne
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) DeleteOne(user *models.Usertab, shipOrderId string, itemId string) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "DeleteOneShipOrderItemlst", "删除一个ShipOrderItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(shipOrderId, itemId)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(shipOrderId, itemId)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.SelectOne
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) SelectOne(user *models.Usertab, shipOrderId string, itemId string) (*model.ShipOrderItemlst, error) {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "SelectOneShipOrderItemlst", "查询一个ShipOrderItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(shipOrderId, itemId)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.UpdateOne
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) UpdateOne(user *models.Usertab, entity *model.ShipOrderItemlst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "UpdateOneShipOrderItemlst", "修改一个ShipOrderItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.ShipOrderId, entity.ItemId)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.Insert
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) Insert(user *models.Usertab, entities *[]model.ShipOrderItemlst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "InsertShipOrderItemlst", "插入多个ShipOrderItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.ShipOrderId, entity.ItemId)
		if err != nil {
			return err
		}
		if record != nil {
			return grmi.NewBusinessError("已经存在相同主键的记录!")
		}
	}

	err := dao.Insert(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.Delete
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) Delete(user *models.Usertab, entities *[]model.ShipOrderItemlst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "DeleteShipOrderItemlst", "删除多个ShipOrderItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.ShipOrderId, entity.ItemId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Delete(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.Select
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) Select(user *models.Usertab, urlParameters map[string]string) ([]model.ShipOrderItemlst, error) {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "SelectShipOrderItemlst", "查询ShipOrderItemlst")

	condition := DefaultConditionOfShipOrderItemlstAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)
	//if condition.Fill(urlParameters) {
	//	result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
	//	if err != nil {
	//		return nil, err
	//	}
	//	return result, nil
	//} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	//}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/jit/ShipOrderItemlstService.Update
 *
 ******************************************************************************/
func (impl *ShipOrderItemlstServiceImplement) Update(user *models.Usertab, entities *[]model.ShipOrderItemlst) error {

	grmi.Log(user, "/services/jit/implments/ShipOrderItemlst.service.impl.go", "UpdateShipOrderItemlst", "修改多个ShipOrderItemlst")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewShipOrderItemlstDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.ShipOrderId, entity.ItemId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Update(entities)
	if err != nil {
		return err
	}
	return nil
}
