// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	apiDal "LAPP_GAAS_GFrame_BACKEND/dao/api"
	baseDal "LAPP_GAAS_GFrame_BACKEND/dao/base"
	meDal "LAPP_GAAS_GFrame_BACKEND/dao/me"
	apiMeta "LAPP_GAAS_GFrame_BACKEND/meta/api"
	baseMeta "LAPP_GAAS_GFrame_BACKEND/meta/base"
	meMeta "LAPP_GAAS_GFrame_BACKEND/meta/me"
	//logDal "LAPP_GAAS_GFrame_BACKEND/dao/log"
	dal "LAPP_GAAS_GFrame_BACKEND/dao/om"
	"LAPP_GAAS_GFrame_BACKEND/db"
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	"LAPP_GAAS_GFrame_BACKEND/infra/logger"
	//logMeta "LAPP_GAAS_GFrame_BACKEND/meta/log"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/om"
	baseModel "LAPP_GAAS_GFrame_BACKEND/models/base"
	//logModel "LAPP_GAAS_GFrame_BACKEND/models/log"
	model "LAPP_GAAS_GFrame_BACKEND/models/om"
	"LAPP_GAAS_GFrame_BACKEND/utils"
	"LAPP_GAAS_GFrame_BACKEND/web/models"
	"strconv"
	"time"
)

/******************************************************************************
 *
 * @Description              : WorkOrder的默认查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-22 16:45:05
 *
 ******************************************************************************/
var DefaultConditionOfWorkOrder = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.WorkOrder_WorkOrderId.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_WorkOrderId, grmi.Equal, true),
		meta.WorkOrder_ArtId.UrlParameterName:                grmi.NewConditionItem(meta.WorkOrder_ArtId, grmi.Equal, false),
		meta.WorkOrder_CustArtId.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_CustArtId, grmi.Equal, false),
		meta.WorkOrder_RouteTemplateId.UrlParameterName:      grmi.NewConditionItem(meta.WorkOrder_RouteTemplateId, grmi.Equal, false),
		meta.WorkOrder_OrderType.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_OrderType, grmi.Equal, false),
		meta.WorkOrder_OrderType1.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_OrderType1, grmi.Equal, false),
		meta.WorkOrder_OrderType2.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_OrderType2, grmi.Equal, false),
		meta.WorkOrder_OrderInfo.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_OrderInfo, grmi.Equal, false),
		meta.WorkOrder_CustOrderId.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_CustOrderId, grmi.Equal, false),
		meta.WorkOrder_ErpOrderId.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_ErpOrderId, grmi.Equal, false),
		meta.WorkOrder_ParentOrderId.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_ParentOrderId, grmi.Equal, false),
		meta.WorkOrder_Priority.UrlParameterName:             grmi.NewConditionItem(meta.WorkOrder_Priority, grmi.Equal, false),
		meta.WorkOrder_PlanResourceGroupId.UrlParameterName:  grmi.NewConditionItem(meta.WorkOrder_PlanResourceGroupId, grmi.Equal, false),
		meta.WorkOrder_PlanResourceId.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_PlanResourceId, grmi.Equal, false),
		meta.WorkOrder_UsedResourceId.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_UsedResourceId, grmi.Equal, false),
		meta.WorkOrder_PlanQty.UrlParameterName:              grmi.NewConditionItem(meta.WorkOrder_PlanQty, grmi.Equal, false),
		meta.WorkOrder_QtyUomId.UrlParameterName:             grmi.NewConditionItem(meta.WorkOrder_QtyUomId, grmi.Equal, false),
		meta.WorkOrder_RatePerHourToggle.UrlParameterName:    grmi.NewConditionItem(meta.WorkOrder_RatePerHourToggle, grmi.Equal, false),
		meta.WorkOrder_TimePerItemToggle.UrlParameterName:    grmi.NewConditionItem(meta.WorkOrder_TimePerItemToggle, grmi.Equal, false),
		meta.WorkOrder_TimePerBatchToggle.UrlParameterName:   grmi.NewConditionItem(meta.WorkOrder_TimePerBatchToggle, grmi.Equal, false),
		meta.WorkOrder_BatchTimeFieldToggle.UrlParameterName: grmi.NewConditionItem(meta.WorkOrder_BatchTimeFieldToggle, grmi.Equal, false),
		meta.WorkOrder_OpTimePerItem.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_OpTimePerItem, grmi.Equal, false),
		meta.WorkOrder_BatchTime.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_BatchTime, grmi.Equal, false),
		meta.WorkOrder_QuantityPerHour.UrlParameterName:      grmi.NewConditionItem(meta.WorkOrder_QuantityPerHour, grmi.Equal, false),
		meta.WorkOrder_BatchQuantity.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_BatchQuantity, grmi.Equal, false),
		meta.WorkOrder_TimeUomId.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_TimeUomId, grmi.Equal, false),
		meta.WorkOrder_BatchingMethod.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_BatchingMethod, grmi.Equal, false),
		meta.WorkOrder_PlanStartDate.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_PlanStartDate, grmi.Approximate, false),
		meta.WorkOrder_PlanEndDate.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_PlanEndDate, grmi.Approximate, false),
		meta.WorkOrder_SetupStartTime.UrlParameterName:       grmi.NewConditionItem(meta.WorkOrder_SetupStartTime, grmi.Approximate, false),
		meta.WorkOrder_SetupEndTime.UrlParameterName:         grmi.NewConditionItem(meta.WorkOrder_SetupEndTime, grmi.Approximate, false),
		meta.WorkOrder_PlanStartTime.UrlParameterName:        grmi.NewConditionItem(meta.WorkOrder_PlanStartTime, grmi.Approximate, false),
		meta.WorkOrder_PlanEndTime.UrlParameterName:          grmi.NewConditionItem(meta.WorkOrder_PlanEndTime, grmi.Approximate, false),
		meta.WorkOrder_ActStartTime.UrlParameterName:         grmi.NewConditionItem(meta.WorkOrder_ActStartTime, grmi.Approximate, false),
		meta.WorkOrder_ActEndTime.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_ActEndTime, grmi.Approximate, false),
		meta.WorkOrder_ProjectId.UrlParameterName:            grmi.NewConditionItem(meta.WorkOrder_ProjectId, grmi.Equal, false),
		meta.WorkOrder_CustomerId.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_CustomerId, grmi.Equal, false),
		meta.WorkOrder_CustomerName.UrlParameterName:         grmi.NewConditionItem(meta.WorkOrder_CustomerName, grmi.Equal, false),
		meta.WorkOrder_FixStartTimeToggle.UrlParameterName:   grmi.NewConditionItem(meta.WorkOrder_FixStartTimeToggle, grmi.Equal, false),
		meta.WorkOrder_LastModify.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_LastModify, grmi.Approximate, false),
		meta.WorkOrder_LastUser.UrlParameterName:             grmi.NewConditionItem(meta.WorkOrder_LastUser, grmi.Equal, false),
		meta.WorkOrder_CreateTime.UrlParameterName:           grmi.NewConditionItem(meta.WorkOrder_CreateTime, grmi.Approximate, false),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : WorkOrder的默认分页查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 14:04:47
 *
 ******************************************************************************/
var DefaultConditionOfWorkOrderAndPaging = grmi.NewCondition(
	DefaultConditionOfWorkOrder.Items,
	grmi.NewPaging(),
)

/******************************************************************************
 *
 * @Struct Name              : WorkOrderServiceImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : WorkOrder的服务实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 14:04:47
 *
 ******************************************************************************/
type WorkOrderServiceImplement struct {
}

/******************************************************************************
 *
 * @Function Name            : NewWorkOrderDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkOrderDAOImplement实例
 *
 * @Return Value             : WorkOrderDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 14:04:47
 *
 ******************************************************************************/
func NewWorkOrderServiceImplement() *WorkOrderServiceImplement {
	return &WorkOrderServiceImplement{}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.InsertOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) InsertOne(user *models.Usertab, entity *model.WorkOrderJoin) error {
	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "InsertOneWorkOrder", "插入一个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	articleDao := baseDal.NewArticleDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	// 获取物料数据 并校验
	article, err := articleDao.SelectOne(entity.WorkOrder.ArtId)
	if err != nil {
		return grmi.NewBusinessError("查询物料数据失败, error:" + err.Error())
	}
	if article == nil {
		return grmi.NewBusinessError("订单物料数据不存在")
	}
	if article.Status != baseModel.ARTICLE_STATUS_USED {
		return grmi.NewBusinessError("物料未启用,物料ID:" + entity.WorkOrder.ArtId)
	}
	// 校验工单数量和状态 计划时间
	workOrder := entity.WorkOrder
	workQty := entity.WorkOrderQty
	workStatus := entity.WorkOrderStatus
	if workStatus.Status != baseModel.WO_STATUS_UNPLANNED {
		return grmi.NewBusinessError("创建的订单状态不合规,status:" + strconv.Itoa(entity.Status))
	}
	startDate := workOrder.PlanStartDate.Restore()
	endDate := workOrder.PlanEndDate.Restore()
	if endDate.Before(startDate) {
		return grmi.NewBusinessError("创建的订单状态计划时间不合规")
	}
	createQty := workQty.PlanQty
	if createQty == 0 {
		return grmi.NewBusinessError("创建的订单的数量为0")
	}
	// 根据不同的物料类型 创建批次工单
	if article.ArtSpec1 == "CarSet" {
		// 派生的总成创建底下实际总成
		bomLstDao := meDal.NewBomLstDAO(session, user.Pid, user.Userid)
		bomLstLi, err := bomLstDao.Select([]grmi.Predicate{meMeta.BomLst_BomId.NewPredicate(grmi.Equal, article.ArtId)}, []grmi.Field{meMeta.BomLst_Position})
		if err != nil {
			return grmi.NewBusinessError("获取物料BOM数据失败, error:" + err.Error())
		}
		if len(bomLstLi) == 0 {
			return grmi.NewBusinessError("创建的物料是派生， 但是未获取到BOM数据")
		}
		if err := session.Begin(); err != nil {
			return grmi.NewBusinessError("开启事务失败, error:" + err.Error())
		}
		for _, bomLst := range bomLstLi {
			qty := bomLst.CmatQty / bomLst.FmatQty
			productQty := createQty * qty
			bomArticle, err := articleDao.SelectOne(bomLst.CmatNr)
			if err != nil {
				_ = session.Rollback()
				return grmi.NewBusinessError("查询物料数据失败，error:" + err.Error())
			}
			if bomArticle == nil {
				_ = session.Rollback()
				return grmi.NewBusinessError("BOM关联的物料不存在, artId:" + bomLst.CmatNr)
			}
			if bomArticle.Status != baseModel.ARTICLE_STATUS_USED {
				return grmi.NewBusinessError("物料未启用,物料ID:" + bomArticle.ArtId)
			}
			snr := new(models.Snrtab)
			snr.Finr = user.Pid
			workOrderId, err := snr.GetNextSnrWithSession(session, "WorkOrder")
			if err != nil {
				_ = session.Rollback()
				return grmi.NewBusinessError("生成工单流水号失败, error:" + err.Error())
			}
			workOrder.WorkOrderId = workOrderId
			workOrder.PlanResourceId = bomArticle.PlanResourceId
			workOrder.UsedResourceId = bomArticle.UsedResourceId
			workOrder.QuantityPerHour = bomArticle.QuantityPerHour
			workOrder.RatePerHourToggle = bomArticle.RatePerHourToggle
			workOrder.ArtId = bomArticle.ArtId
			workOrder.PlanQty = productQty
			workQty.WorkOrderId = workOrder.WorkOrderId
			workQty.PlanQty = productQty
			workStatus.WorkOrderId = workOrder.WorkOrderId
			err = dao.InsertOne(workOrder)
			if err != nil {
				_ = session.Rollback()
				return grmi.NewBusinessError("插入工单数据失败, error:" + err.Error())
			}
			err = statusDao.InsertOne(workStatus)
			if err != nil {
				_ = session.Rollback()
				return grmi.NewBusinessError("插入工单状态数据失败， error:" + err.Error())
			}
			err = qtyDao.InsertOne(workQty)
			if err != nil {
				_ = session.Rollback()
				return grmi.NewBusinessError("插入工单数量数据失败, error:" + err.Error())
			}
		}
	} else {
		if err := session.Begin(); err != nil {
			return grmi.NewBusinessError("开启事务失败, error:" + err.Error())
		}
		snr := new(models.Snrtab)
		snr.Finr = user.Pid
		workOrderId, err := snr.GetNextSnrWithSession(session, "WorkOrder")
		if err != nil {
			_ = session.Rollback()
			return grmi.NewBusinessError("生成批次工单流水号失败, error:" + err.Error())
		}
		workOrder.WorkOrderId = workOrderId
		workQty.WorkOrderId = workOrder.WorkOrderId
		workStatus.WorkOrderId = workOrder.WorkOrderId
		err = dao.InsertOne(workOrder)
		if err != nil {
			_ = session.Rollback()
			return grmi.NewBusinessError("插入工单数据失败, error:" + err.Error())
		}
		err = statusDao.InsertOne(workStatus)
		if err != nil {
			_ = session.Rollback()
			return grmi.NewBusinessError("插入工单状态数据失败， error:" + err.Error())
		}
		err = qtyDao.InsertOne(workQty)
		if err != nil {
			_ = session.Rollback()
			return grmi.NewBusinessError("插入工单数量数据失败, error:" + err.Error())
		}

	}
	_ = session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) DeleteOne(user *models.Usertab, workOrderId string) error {
	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "DeleteOneWorkOrder", "删除一个WorkOrder")
	log, _ := logger.NewLogger(user.Userid, "OM")
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	err := session.Begin()
	if err != nil {
		return err
	}
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	statusRecDao := dal.NewWorkOrderStatusRecLstDAO(session, user.Pid, user.Userid)
	//artDemandHeadDao := logDal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	//artDemandLstDao := logDal.NewArtDemandLstDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(workOrderId)
	if err != nil {
		log.Error("WorkOrder DeleteOne select workOrder failed, error: " + err.Error())
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定workOrder记录!")
	}
	statusRecord, err := statusDao.SelectOne(workOrderId)
	if err != nil {
		log.Error("WorkOrder DeleteOne select workOrder status failed, error: " + err.Error())
		return err
	}
	if statusRecord == nil {
		return grmi.NewBusinessError("不存在指定workOrderStatus记录!")
	}
	qtyRecord, err := qtyDao.SelectOne(workOrderId)
	if err != nil {
		log.Error("WorkOrder DeleteOne select workOrder qty failed, error: " + err.Error())
		return err
	}
	if qtyRecord == nil {
		return grmi.NewBusinessError("不存在指定workOrderQty记录!")
	}
	if statusRecord.Status != baseModel.WO_STATUS_UNPLANNED {
		return grmi.NewBusinessError("该workOrder不可以删除, status:" + strconv.Itoa(statusRecord.Status))
	}
	//maxPos, err := statusRecDao.GetMaxPos(record.WorkOrderId)
	//if err != nil {
	//	log.Error("WorkOrder DeleteOne get status rec max pos failed, error: " + err.Error())
	//	session.Rollback()
	//	return err
	//}
	var workOrderStatusRec model.WorkOrderStatusRecLst
	workOrderStatusRec.WorkOrderId = record.WorkOrderId
	workOrderStatusRec.PrevStatus = statusRecord.Status
	workOrderStatusRec.Status = baseModel.WO_STATUS_CANCELED
	//workOrderStatusRec.Pos = maxPos + 1
	err = statusRecDao.InsertOne(&workOrderStatusRec)
	if err != nil {
		log.Error("WorkOrder DeleteOne insert status rec failed, error: " + err.Error())
		session.Rollback()
		return err
	}
	statusRecord.Status = baseModel.WO_STATUS_CANCELED
	err = statusDao.UpdateOne(statusRecord)
	if err != nil {
		log.Error("WorkOrder DeleteOne update work order status failed, error: " + err.Error())
		session.Rollback()
		return err
	}
	// 从供应商门户处处理对应的需求数据
	//artDemandHeadLi, err := artDemandHeadDao.SelectByEndDate(record.ArtId, record.PlanEndDate.Restore().Format("2006-01-02"))
	//if err != nil {
	//	log.Error("WorkOrder DeleteOne get art demand head failed, error: " + err.Error())
	//	session.Rollback()
	//	return err
	//}
	//if len(artDemandHeadLi) != 0 {
	//	artDemandHead := artDemandHeadLi[0]
	//	artDemandHead.OrderStatus = statusRecord.Status
	//	err = artDemandHeadDao.UpdateOne(&artDemandHead)
	//	if err != nil {
	//		log.Error("WorkOrder DeleteOne update art demand head failed, error: " + err.Error())
	//		session.Rollback()
	//		return err
	//	}
	//	//err = artDemandLstDao.DeleteWhere([]grmi.Predicate{logMeta.ArtDemandLst_DemandId.NewPredicate(grmi.Equal, artDemandHead.DemandId)})
	//	//if err != nil {
	//	//	log.Error("WorkOrder DeleteOne delete art demand lst failed, error: " + err.Error())
	//	//	session.Rollback()
	//	//	return err
	//	//}
	//}
	session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.SelectOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) SelectOne(user *models.Usertab, workOrderId string) (*model.WorkOrderJoin, error) {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "SelectOneWorkOrder", "查询一个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	workOrder, err := dao.SelectOne(workOrderId)
	if err != nil {
		return nil, err
	}
	if workOrder == nil {
		return nil, grmi.NewBusinessError("workOrder不存在")
	}
	workOrderStatus, err := statusDao.SelectOne(workOrderId)
	if err != nil {
		return nil, err
	}
	workOrderQty, err := qtyDao.SelectOne(workOrderId)
	if err != nil {
		return nil, err
	}
	data := &model.WorkOrderJoin{
		WorkOrder:       workOrder,
		WorkOrderQty:    workOrderQty,
		WorkOrderStatus: workOrderStatus,
	}

	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) UpdateOne(user *models.Usertab, entity *model.WorkOrderJoin) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "UpdateOneWorkOrder", "修改一个WorkOrder")
	//log, _ := logger.NewLogger(user.Userid, "OM")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	if err := session.Begin(); err != nil {
		return err
	}
	defer session.Close()
	workOrder := entity.WorkOrder
	workOrderStatus := entity.WorkOrderStatus
	workOrderQty := entity.WorkOrderQty
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	//artDemandHeadDao := logDal.NewArtDemandHeadDAO(session, user.Pid, user.Userid)
	workOrderRecord, err := dao.SelectOne(workOrder.WorkOrderId)
	if err != nil {
		return err
	}
	if workOrderRecord == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	statusRecord, err := statusDao.SelectOne(workOrder.WorkOrderId)
	if err != nil {
		return err
	}
	if statusRecord == nil {
		return grmi.NewBusinessError("不存在指定的WorkOrderStatus")
	}
	qtyRecord, err := qtyDao.SelectOne(workOrder.WorkOrderId)
	if err != nil {
		return err
	}
	if qtyRecord == nil {
		return grmi.NewBusinessError("不存在指定的WorkOrderQty")
	}
	if workOrderStatus.Status != statusRecord.Status {
		return grmi.NewBusinessError("workOrderStatus不允许修改")
	}
	err = dao.UpdateOne(workOrder)
	if err != nil {
		session.Rollback()
		return err
	}
	workOrderQty.WorkOrderId = qtyRecord.WorkOrderId
	err = qtyDao.UpdateOne(workOrderQty)
	if err != nil {
		session.Rollback()
		return err
	}
	// 从供应商门户处处理对应的需求数据
	//artDemandHeadLi, err := artDemandHeadDao.SelectByEndDate(workOrderRecord.ArtId, workOrderRecord.PlanEndDate.Restore().Format("2006-01-02"))
	//if err != nil {
	//	log.Error("WorkOrder UpdateOne get art demand head failed, error: " + err.Error())
	//	session.Rollback()
	//	return err
	//}
	//if len(artDemandHeadLi) != 0 {
	//	artDemandHead := artDemandHeadLi[0]
	//	artDemandHead.OrderStatus = statusRecord.Status
	//	artDemandHead.DemandQty = qtyRecord.PlanQty
	//	artDemandHead.UnproducedQty = qtyRecord.PlanQty
	//	err = artDemandHeadDao.UpdateOne(&artDemandHead)
	//	if err != nil {
	//		log.Error("WorkOrder UpdateOne update art demand head failed, error: " + err.Error())
	//		session.Rollback()
	//		return err
	//	}
	//	//err = artDemandLstDao.DeleteWhere([]grmi.Predicate{logMeta.ArtDemandLst_DemandId.NewPredicate(grmi.Equal, artDemandHead.DemandId)})
	//	//if err != nil {
	//	//	log.Error("WorkOrder DeleteOne delete art demand lst failed, error: " + err.Error())
	//	//	session.Rollback()
	//	//	return err
	//	//}
	//}
	session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Insert
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Insert(user *models.Usertab, entities *[]model.WorkOrder) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "InsertWorkOrder", "插入多个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.WorkOrderId)
		if err != nil {
			return err
		}
		if record != nil {
			return grmi.NewBusinessError("已经存在相同主键的记录!")
		}
	}

	err := dao.Insert(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Delete
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Delete(user *models.Usertab, entities *[]model.WorkOrder) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "DeleteWorkOrder", "删除多个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.WorkOrderId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Delete(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Select
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Select(user *models.Usertab, urlParameters map[string]string) (interface{}, error) {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "SelectWorkOrder", "查询WorkOrder")
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	var projectId string
	var artId string
	var timeStart string
	var timeEnd string
	var workOrderId string
	var orderType string
	var statusStr string
	var pageNumberStr string
	var pageSizeStr string
	projectId, _ = urlParameters["ProjectId"]
	artId, _ = urlParameters["ArtId"]
	workOrderId, _ = urlParameters["WorkOrderId"]
	timeStart, _ = urlParameters["start"]
	timeEnd, _ = urlParameters["end"]
	orderType, _ = urlParameters["OrderType"]
	statusStr, _ = urlParameters["status"]
	pageNumberStr, _ = urlParameters["pageNumber"]
	pageSizeStr, _ = urlParameters["pageSize"]
	status, err := strconv.Atoi(statusStr)
	if err != nil {
		status = 0
	}
	if timeStart != "" {
		_, err = time.ParseInLocation("2006-01-02 15:04:05", timeStart, utils.TimezoneLocation)
		if err != nil {
			return nil, err
		}
	}
	if timeEnd != "" {
		_, err = time.ParseInLocation("2006-01-02 15:04:05", timeEnd, utils.TimezoneLocation)
		if err != nil {
			return nil, err
		}
	}
	pageNumber, err := strconv.Atoi(pageNumberStr)
	if err != nil {
		pageNumber = 1
	}
	pageSize, err := strconv.Atoi(pageSizeStr)
	if err != nil {
		pageSize = 10
	}
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	roleRelDao := baseDal.NewRoleRelDAO(session, user.Pid, user.Userid)
	roleRelLi, err := roleRelDao.Select([]grmi.Predicate{baseMeta.RoleRel_RoleId.NewPredicate(grmi.Equal, user.RoleId)}, nil)
	if err != nil {
		return nil, err
	}
	workLineIdLi := make([]string, 0, len(roleRelLi))
	for _, roleRel := range roleRelLi {
		workLineIdLi = append(workLineIdLi, roleRel.WorkLineid)
	}
	result, err := dao.SelectByPage(projectId, artId, timeStart, timeEnd, workOrderId, orderType, status, pageNumber, pageSize, workLineIdLi)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Update
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Update(user *models.Usertab, entities *[]model.WorkOrder) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "UpdateWorkOrder", "修改多个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.WorkOrderId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Update(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.Revocation
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) Revocation(user *models.Usertab, entities []string) error {

	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "UpdateOneWorkOrder", "修改一个WorkOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	err := session.Begin()
	if err != nil {
		return err
	}
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	statusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	qtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	for _, workOrderId := range entities {
		workOrderRecord, err := dao.SelectOne(workOrderId)
		if err != nil {
			return err
		}
		if workOrderRecord == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
		statusRecord, err := statusDao.SelectOne(workOrderId)
		if err != nil {
			return err
		}
		if statusRecord == nil {
			return grmi.NewBusinessError("不存在指定的WorkOrderStatus")
		}
		qtyRecord, err := qtyDao.SelectOne(workOrderId)
		if err != nil {
			return err
		}
		if qtyRecord == nil {
			return grmi.NewBusinessError("不存在指定的WorkOrderQty")
		}
		if statusRecord.Status > baseModel.WO_STATUS_PLANNED {
			return grmi.NewBusinessError("该订单状态不支持撤销,status:" + strconv.Itoa(statusRecord.Status))
		}
		statusRecord.Status = baseModel.WO_STATUS_UNPLANNED
		err = statusDao.UpdateOne(statusRecord)
		if err != nil {
			session.Rollback()
			return err
		}
	}
	session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.CancelWorkOrder
 *
 ******************************************************************************/
func (impl WorkOrderServiceImplement) CancelWorkOrder(user *models.Usertab, workOrderId string, qty float64) (err error) {
	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "CancelWorkOrder", "取消workOrder中指定数量的serialOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	if err = session.Begin(); err != nil {
		return err
	}
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	workOrderQtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	workOrderStatusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	workOrderStatusRecDao := dal.NewWorkOrderStatusRecLstDAO(session, user.Pid, user.Userid)
	serialOrderDao := dal.NewSerialOrderDAO(session, user.Pid, user.Userid)
	serialOrderStatusDao := dal.NewSerialOrderStatusDAO(session, user.Pid, user.Userid)
	serialOrderStatusRecDao := dal.NewSerialOrderStatusRecLstDAO(session, user.Pid, user.Userid)
	workOrder, err := dao.SelectOneJoin(workOrderId)
	if err != nil {
		_ = session.Rollback()
		return err
	}
	if workOrder == nil {
		_ = session.Rollback()
		return grmi.NewBusinessError("workOrder不存在")
	}
	if workOrder.WorkOrderStatus.Status != baseModel.WO_STATUS_LOCKED && workOrder.WorkOrderStatus.Status != baseModel.WO_STATUS_RELEASED && workOrder.WorkOrderStatus.Status != baseModel.WO_STATUS_RUNNING {
		_ = session.Rollback()
		return grmi.NewBusinessError("workOrder目前的状态不支持该操作")
	}
	if qty > (workOrder.WorkOrderQty.PlanQty - workOrder.WorkOrderQty.ReleasedQty) {
		_ = session.Rollback()
		return grmi.NewBusinessError("workOrder未派工数量不足")
	}
	workOrder.WorkOrderQty.ReleasedQty += qty
	workOrder.WorkOrderQty.ActQty3 += qty
	workOrder.WorkOrderQty.ActQty += qty
	err = workOrderQtyDao.UpdateOne(&workOrder.WorkOrderQty)
	if err != nil {
		_ = session.Rollback()
		return err
	}
	if workOrder.WorkOrderQty.PlanQty == workOrder.WorkOrderQty.ReleasedQty && workOrder.WorkOrderQty.ReleasedQty == workOrder.WorkOrderQty.ActQty {
		var status int
		if workOrder.WorkOrderQty.PlanQty == workOrder.WorkOrderQty.ActQty3 {
			status = baseModel.WO_STATUS_CANCELED
		} else {
			status = baseModel.WO_STATUS_FINISHED
		}
		workOrderStatusRec := model.WorkOrderStatusRecLst{
			WorkOrderId: workOrderId,
			PrevStatus:  workOrder.WorkOrderStatus.Status,
			Status:      status,
		}
		err = workOrderStatusRecDao.InsertOne(&workOrderStatusRec)
		if err != nil {
			_ = session.Rollback()
			return err
		}
		workOrder.WorkOrderStatus.Status = status
		err = workOrderStatusDao.UpdateOne(&workOrder.WorkOrderStatus)
		if err != nil {
			_ = session.Rollback()
			return err
		}
	}
	serialOrderLi, err := serialOrderDao.SelectByWorkOrderId(workOrderId, baseModel.WO_STATUS_LOCKED)
	if err != nil {
		_ = session.Rollback()
		return err
	}
	if len(serialOrderLi) < int(qty) {
		_ = session.Rollback()
		return grmi.NewBusinessError("未派工的序列工单不足")
	}
	for i := 0; i < int(qty); i++ {
		serialOrder := serialOrderLi[i]
		serialOrderStatusRec := model.SerialOrderStatusRecLst{
			SerialOrderId: serialOrder.SerialOrderId,
			PrevStatus:    serialOrder.SerialOrderStatus.Status,
			Status:        baseModel.WO_STATUS_CANCELED,
		}
		err = serialOrderStatusRecDao.InsertOne(&serialOrderStatusRec)
		if err != nil {
			_ = session.Rollback()
			return err
		}
		serialOrder.SerialOrderStatus.Status = baseModel.WO_STATUS_CANCELED
		err = serialOrderStatusDao.UpdateForStatus(&serialOrder.SerialOrderStatus, baseModel.WO_STATUS_LOCKED)
		if err != nil {
			_ = session.Rollback()
			return err
		}
	}
	slaves := db.Eloquent.Slaves()
	if len(slaves) == 0 {
		return grmi.NewBusinessError("未获取到mes的数据库")
	}
	mesEngine := slaves[0]
	mesSession := mesEngine.NewSession()
	defer mesSession.Close()
	if err = mesSession.Begin(); err != nil {
		_ = session.Rollback()
		_ = mesSession.Rollback()
		return err
	}
	headerDao := apiDal.NewACCWOWORKORDERHEADERDAO(mesSession, user.Userid)
	mesWorkOrderLi, err := headerDao.Select([]grmi.Predicate{apiMeta.ACCWOWORKORDERHEADER_WONO.NewPredicate(grmi.Equal, workOrderId)}, nil, 1)
	if err != nil {
		_ = mesSession.Rollback()
		_ = session.Rollback()
		return err
	}
	if len(mesWorkOrderLi) == 0 {
		_ = mesSession.Rollback()
		_ = session.Rollback()
		return grmi.NewBusinessError("未从mes系统获取到workOrder")
	}
	mesWorkOrder := mesWorkOrderLi[0]
	preQty := mesWorkOrder.QUANTITY
	mesWorkOrder.QUANTITY += int(qty)
	if mesWorkOrder.QUANTITY == mesWorkOrder.PLANQUANTITY {
		mesWorkOrder.STATUS = model.MesOrderStatusAccomplished
		mesWorkOrder.FINISHTIME = grmi.DateTime(time.Now())
	}
	err = headerDao.UpdateForQty(&mesWorkOrder, preQty)
	if err != nil {
		_ = mesSession.Rollback()
		_ = session.Rollback()
		return err
	}
	_ = mesSession.Commit()
	_ = session.Commit()
	return nil

}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.CancelReleaseSerialOrder
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) CancelReleaseSerialOrder(user *models.Usertab, workOrderId string, qty float64) (err error) {
	grmi.Log(user, "/services/om/implments/WorkOrder.service.impl.go", "CancelMesSerialOrder", "取消已派工的workOrder中指定数量的serialOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	if err = session.Begin(); err != nil {
		return err
	}
	dao := dal.NewWorkOrderDAO(session, user.Pid, user.Userid)
	workOrderQtyDao := dal.NewWorkOrderQtyDAO(session, user.Pid, user.Userid)
	workOrderStatusDao := dal.NewWorkOrderStatusDAO(session, user.Pid, user.Userid)
	workOrderStatusRecDao := dal.NewWorkOrderStatusRecLstDAO(session, user.Pid, user.Userid)
	serialOrderDao := dal.NewSerialOrderDAO(session, user.Pid, user.Userid)
	serialOrderStatusDao := dal.NewSerialOrderStatusDAO(session, user.Pid, user.Userid)
	serialOrderStatusRecDao := dal.NewSerialOrderStatusRecLstDAO(session, user.Pid, user.Userid)
	workOrder, err := dao.SelectOneJoin(workOrderId)
	if err != nil {
		_ = session.Rollback()
		return err
	}
	if workOrder == nil {
		_ = session.Rollback()
		return grmi.NewBusinessError("workOrder不存在")
	}
	if workOrder.WorkOrderStatus.Status != baseModel.WO_STATUS_RELEASED && workOrder.WorkOrderStatus.Status != baseModel.WO_STATUS_RUNNING {
		_ = session.Rollback()
		return grmi.NewBusinessError("workOrder目前的状态不支持该操作")
	}
	if qty > (workOrder.WorkOrderQty.ReleasedQty - workOrder.WorkOrderQty.ActQty) {
		_ = session.Rollback()
		return grmi.NewBusinessError("workOrder派工未完成的数量不足")
	}
	workOrder.WorkOrderQty.ActQty3 += qty
	workOrder.WorkOrderQty.ActQty += qty
	err = workOrderQtyDao.UpdateOne(&workOrder.WorkOrderQty)
	if err != nil {
		_ = session.Rollback()
		return err
	}
	if workOrder.WorkOrderQty.PlanQty == workOrder.WorkOrderQty.ReleasedQty && workOrder.WorkOrderQty.ReleasedQty == workOrder.WorkOrderQty.ActQty {
		var status int
		if workOrder.WorkOrderQty.PlanQty == workOrder.WorkOrderQty.ActQty3 {
			status = baseModel.WO_STATUS_CANCELED
		} else {
			status = baseModel.WO_STATUS_FINISHED
		}
		workOrderStatusRec := model.WorkOrderStatusRecLst{
			WorkOrderId: workOrderId,
			PrevStatus:  workOrder.WorkOrderStatus.Status,
			Status:      status,
		}
		err = workOrderStatusRecDao.InsertOne(&workOrderStatusRec)
		if err != nil {
			_ = session.Rollback()
			return err
		}
		workOrder.WorkOrderStatus.Status = status
		err = workOrderStatusDao.UpdateOne(&workOrder.WorkOrderStatus)
		if err != nil {
			_ = session.Rollback()
			return err
		}
	}

	serialOrderLi, err := serialOrderDao.SelectByWorkOrderId(workOrderId, baseModel.WO_STATUS_RELEASED)
	if err != nil {
		_ = session.Rollback()
		return err
	}
	if int(qty) > len(serialOrderLi) {
		_ = session.Rollback()
		return grmi.NewBusinessError("workOrder派工未完成的数量不足")
	}
	serialOrderIdLi := make([]string, 0, int(qty))
	for i := 0; i < int(qty); i++ {
		serialOrder := serialOrderLi[i]
		serialOrderIdLi = append(serialOrderIdLi, serialOrder.SerialOrderId)
		serialOrderStatusRec := model.SerialOrderStatusRecLst{
			SerialOrderId: serialOrder.SerialOrderId,
			PrevStatus:    serialOrder.SerialOrderStatus.Status,
			Status:        baseModel.WO_STATUS_CANCELED,
		}
		err = serialOrderStatusRecDao.InsertOne(&serialOrderStatusRec)
		if err != nil {
			_ = session.Rollback()
			return err
		}
		serialOrder.SerialOrderStatus.Status = baseModel.WO_STATUS_CANCELED
		err = serialOrderStatusDao.UpdateForStatus(&serialOrder.SerialOrderStatus, baseModel.WO_STATUS_RELEASED)
		if err != nil {
			_ = session.Rollback()
			return err
		}
	}
	slaves := db.Eloquent.Slaves()
	if len(slaves) == 0 {
		return grmi.NewBusinessError("未获取到mes的数据库")
	}
	mesEngine := slaves[0]
	mesSession := mesEngine.NewSession()
	defer mesSession.Close()
	if err = mesSession.Begin(); err != nil {
		_ = session.Rollback()
		_ = mesSession.Rollback()
		return err
	}
	headerDao := apiDal.NewACCWOWORKORDERHEADERDAO(mesSession, user.Userid)
	detailDao := apiDal.NewACCWOWORKORDERDETAILDAO(mesSession, user.Userid)
	mesWorkOrderLi, err := headerDao.Select([]grmi.Predicate{apiMeta.ACCWOWORKORDERHEADER_WONO.NewPredicate(grmi.Equal, workOrderId)}, nil, 1)
	if err != nil {
		_ = mesSession.Rollback()
		_ = session.Rollback()
		return err
	}
	if len(mesWorkOrderLi) == 0 {
		_ = mesSession.Rollback()
		_ = session.Rollback()
		return grmi.NewBusinessError("未从mes系统获取到workOrder")
	}
	mesWorkOrder := mesWorkOrderLi[0]
	preQty := mesWorkOrder.QUANTITY
	mesWorkOrder.QUANTITY += int(qty)
	if mesWorkOrder.QUANTITY == mesWorkOrder.PLANQUANTITY {
		mesWorkOrder.STATUS = model.MesOrderStatusAccomplished
		mesWorkOrder.FINISHTIME = grmi.DateTime(time.Now())
	}
	err = headerDao.UpdateForQty(&mesWorkOrder, preQty)
	if err != nil {
		_ = mesSession.Rollback()
		_ = session.Rollback()
		return err
	}
	for _, serialOrderId := range serialOrderIdLi {
		detailLi, err := detailDao.Select([]grmi.Predicate{apiMeta.ACCWOWORKORDERDETAIL_UNITSN.NewPredicate(grmi.Equal, serialOrderId)}, nil)
		if err != nil {
			_ = mesSession.Rollback()
			_ = session.Rollback()
			return err
		}
		if len(detailLi) == 0 {
			_ = mesSession.Rollback()
			_ = session.Rollback()
			return grmi.NewBusinessError("在MES系统中未获取到对应的序列工单")
		}
		detail := detailLi[0]
		detail.STATUS = model.MesOrderStatusCancel
		err = detailDao.UpdateOneWithPreStatus(&detail, model.MesOrderStatusRelease)
		if err != nil {
			_ = mesSession.Rollback()
			_ = session.Rollback()
			return err
		}
	}
	_ = mesSession.Commit()
	_ = session.Commit()
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/om/WorkOrderService.DashboardDisplay
 *
 ******************************************************************************/
func (impl *WorkOrderServiceImplement) DashboardDisplay(date string, workLineId string) ([]model.VOmWorkorder, error) {
	userId := "dashboard"
	plantId := 100
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewWorkOrderDAO(session, plantId, userId)
	result, err := dao.SelectDisplayWorkOrder(date, workLineId)
	return result, err
}
