// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package qm

import (
	model "LAPP_GAAS_GFrame_BACKEND/models/qm"
	"LAPP_GAAS_GFrame_BACKEND/services/qm/implments"
	"LAPP_GAAS_GFrame_BACKEND/web/models"
)

/******************************************************************************
 *
 * @Interface Name           : ReclinerReclstService
 *-----------------------------------------------------------------------------
 *
 * @Description              : ReclinerReclst的服务接口
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-07-12 14:05:20
 *
 ******************************************************************************/
type ReclinerReclstService interface {
	/******************************************************************************
	 *
	 * @Function Name            : InsertOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 插入一条ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要插入的ReclinerReclst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	InsertOne(*models.Usertab, *model.ReclinerReclst) error
	/******************************************************************************
	 *
	 * @Function Name            : InsertSeriOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 插入一条ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要插入的ReclinerReclst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	InsertSeriOne(*models.Usertab, *model.ReclinerReclst) error
	/******************************************************************************
	 *
	 * @Function Name            : AddPrinterInfo
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 插入一条ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要插入的ReclinerReclst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	AddPrinterInfo(*models.Usertab, *model.ReclinerReclst) error
	/******************************************************************************
	 *
	 * @Function Name            : DeleteOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 删除指定键的ReclinerReclst
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	DeleteOne(*models.Usertab, int) error
	/******************************************************************************
	 *
	 * @Function Name            : SelectOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 查找指定键的ReclinerReclst
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Return Value             : 查找到的ReclinerReclst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	SelectOne(*models.Usertab, int) (*model.ReclinerReclst, error)
	/******************************************************************************
	 *
	 * @Function Name            : SelectSeriOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 查找指定键的ReclinerReclst
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Function Parameters      : 主键
	 *
	 * @Return Value             : 查找到的ReclinerReclst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	SelectSeriOne(*models.Usertab, string) (*model.ReclinerReclst, error)
	/******************************************************************************
	 *
	 * @Function Name            : UpdateOne
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 修改一条ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要修改的ReclinerReclst
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	UpdateOne(*models.Usertab, *model.ReclinerReclst) error
	/******************************************************************************
	 *
	 * @Function Name            : Insert
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 插入多条ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要插入的ReclinerReclst列表
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	Insert(*models.Usertab, *[]model.ReclinerReclst) error
	/******************************************************************************
	 *
	 * @Function Name            : Delete
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 删除多条ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要删除的ReclinerReclst列表
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	Delete(*models.Usertab, *[]model.ReclinerReclst) error
	/******************************************************************************
	 *
	 * @Function Name            : SelectAndPaging
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 查询ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 查询参数
	 *
	 * @Return Value             : 查询结果
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	Select(*models.Usertab, map[string]string) (interface{}, error)
	/******************************************************************************
	 *
	 * @Function Name            : Update
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 修改多条ReclinerReclst
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要修改的ReclinerReclst列表
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-07-12 14:05:20
	 *
	 ******************************************************************************/
	Update(*models.Usertab, *[]model.ReclinerReclst) error

	/******************************************************************************
	 *
	 * @Function Name            : SelectUnPrint
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 查询未打印的包装
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : Article标识
	 *
	 * @Return Value             : 包装单模板,当只有一项返回时,根据返回的模板创建包装单,不会为空,如果未找到模板直接报错.
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 娄文智
	 *
	 * @Date                     : 2021-06-02
	 *
	 ******************************************************************************/
	SelectUnPrint(num int) ([]model.ReclinerReclst, error)
	/******************************************************************************
	 *
	 * @Function Name            : UpdateUnPrint
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 修改多条PackOrder
	 *
	 * @Function Parameters      : 当前访问人员信息
	 *
	 * @Function Parameters      : 需要修改的PackOrder列表
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-03-18 23:20:31
	 *
	 ******************************************************************************/
	UpdateUnPrint(recIds []int) error
	/******************************************************************************
	 *
	 * @Function Name            : CreatePackOrderPrintInfo
	 *-----------------------------------------------------------------------------
	 *
	 * @Description              : 插入打印消息列表
	 *
	 * @Function Parameters      : 查询条件
	 *
	 * @Function Parameters      : 排序字段
	 *
	 * @Return Value             : 查询结果
	 *
	 * @Return Value             : 执行时发生的错误
	 *
	 * @Author                   : 代码生成器创建
	 *
	 * @Date                     : 2021-03-24 09:53:49
	 *
	 ******************************************************************************/
	CreateRecPrintInfo(rec model.ReclinerReclst) error
}

/******************************************************************************
 *
 * @Function Name            : NewReclinerReclstService
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ReclinerReclstService
 *
 * @Return Value             : ReclinerReclstService实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-07-12 14:05:20
 *
 ******************************************************************************/
func NewReclinerReclstService() ReclinerReclstService {
	return implments.NewReclinerReclstServiceImplement()
}
