// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package base

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	svr "LAPP_GAAS_GFrame_BACKEND/services/base"
	"github.com/kataras/iris/v12/core/router"
)

/******************************************************************************
 *
 * @Interface Name           : RegisterRoutes
 *-----------------------------------------------------------------------------
 *
 * @Description              : 注册路由
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-07-21 10:36:05
 *
 ******************************************************************************/
func RegisterRoutes() {
	// 模块base路由分组
	grmi.RegisterRouteMapping("/base", func(party router.Party) {

		// Role的路由组
		role := party.Party("/role")
		// Role的服务实例
		var serviceOfRole = svr.NewRoleService()
		// Role插入一条
		// RegisterInsertOneRole(role, "/insertone", serviceOfRole.InsertOne)
		// Role插入多条
		// RegisterInsertRole(role, "/insert", serviceOfRole.Insert)
		// Role删除一条
		// RegisterDeleteOneRole(role, "/deleteone", serviceOfRole.DeleteOne)
		// Role删除多条
		// RegisterDeleteRole(role, "/delete", serviceOfRole.Delete)
		// Role查询多条
		RegisterSelectRole(role, "/query", serviceOfRole.Select)
		// Role查询一条
		RegisterSelectOneRole(role, "/get", serviceOfRole.SelectOne)
		// Role修改一条
		// RegisterUpdateOneRole(role, "/updateone", serviceOfRole.UpdateOne)
		// Role修改多条
		// RegisterUpdateRole(role, "/update", serviceOfRole.Update)

		// RoleMenu的路由组
		rolemenu := party.Party("/rolemenu")
		// RoleMenu的服务实例
		var serviceOfRoleMenu = svr.NewRoleMenuService()
		// RoleMenu插入一条
		// RegisterInsertOneRoleMenu(rolemenu, "/insertone", serviceOfRoleMenu.InsertOne)
		// RoleMenu插入多条
		// RegisterInsertRoleMenu(rolemenu, "/insert", serviceOfRoleMenu.Insert)
		// RoleMenu删除一条
		// RegisterDeleteOneRoleMenu(rolemenu, "/deleteone", serviceOfRoleMenu.DeleteOne)
		// RoleMenu删除多条
		// RegisterDeleteRoleMenu(rolemenu, "/delete", serviceOfRoleMenu.Delete)
		// RoleMenu查询多条
		RegisterSelectRoleMenu(rolemenu, "/query", serviceOfRoleMenu.Select)
		// RoleMenu查询一条
		RegisterSelectOneRoleMenu(rolemenu, "/get", serviceOfRoleMenu.SelectOne)
		// RoleMenu修改一条
		// RegisterUpdateOneRoleMenu(rolemenu, "/updateone", serviceOfRoleMenu.UpdateOne)
		// RoleMenu修改多条
		// RegisterUpdateRoleMenu(rolemenu, "/update", serviceOfRoleMenu.Update)

		// Stdef的路由组
		stdef := party.Party("/stdef")
		// Stdef的服务实例
		var serviceOfStdef = svr.NewStdefService()
		// Stdef插入一条
		// RegisterInsertOneStdef(stdef, "/insertone", serviceOfStdef.InsertOne)
		// Stdef插入多条
		// RegisterInsertStdef(stdef, "/insert", serviceOfStdef.Insert)
		// Stdef删除一条
		// RegisterDeleteOneStdef(stdef, "/deleteone", serviceOfStdef.DeleteOne)
		// Stdef删除多条
		// RegisterDeleteStdef(stdef, "/delete", serviceOfStdef.Delete)
		// Stdef查询多条
		RegisterSelectStdef(stdef, "/query", serviceOfStdef.Select)
		// Stdef查询一条
		RegisterSelectOneStdef(stdef, "/get", serviceOfStdef.SelectOne)
		// Stdef修改一条
		// RegisterUpdateOneStdef(stdef, "/updateone", serviceOfStdef.UpdateOne)
		// Stdef修改多条
		// RegisterUpdateStdef(stdef, "/update", serviceOfStdef.Update)

		// Menu的路由组
		menu := party.Party("/menu")
		// Menu的服务实例
		var serviceOfMenu = svr.NewMenuService()
		// Menu插入一条
		// RegisterInsertOneMenu(menu, "/insertone", serviceOfMenu.InsertOne)
		// Menu插入多条
		// RegisterInsertMenu(menu, "/insert", serviceOfMenu.Insert)
		// Menu删除一条
		// RegisterDeleteOneMenu(menu, "/deleteone", serviceOfMenu.DeleteOne)
		// Menu删除多条
		// RegisterDeleteMenu(menu, "/delete", serviceOfMenu.Delete)
		// Menu查询多条
		RegisterSelectMenu(menu, "/query", serviceOfMenu.Select)
		// Menu查询一条
		RegisterSelectOneMenu(menu, "/get", serviceOfMenu.SelectOne)
		// Menu修改一条
		// RegisterUpdateOneMenu(menu, "/updateone", serviceOfMenu.UpdateOne)
		// Menu修改多条
		// RegisterUpdateMenu(menu, "/update", serviceOfMenu.Update)

		// TabColName的路由组
		tabcolname := party.Party("/tabcolname")
		// TabColName的服务实例
		var serviceOfTabColName = svr.NewTabColNameService()
		// TabColName插入一条
		// RegisterInsertOneTabColName(tabcolname, "/insertone", serviceOfTabColName.InsertOne)
		// TabColName插入多条
		// RegisterInsertTabColName(tabcolname, "/insert", serviceOfTabColName.Insert)
		// TabColName删除一条
		// RegisterDeleteOneTabColName(tabcolname, "/deleteone", serviceOfTabColName.DeleteOne)
		// TabColName删除多条
		// RegisterDeleteTabColName(tabcolname, "/delete", serviceOfTabColName.Delete)
		// TabColName查询多条
		RegisterSelectTabColName(tabcolname, "/query", serviceOfTabColName.Select)
		// TabColName查询一条
		RegisterSelectOneTabColName(tabcolname, "/get", serviceOfTabColName.SelectOne)
		// TabColName修改一条
		// RegisterUpdateOneTabColName(tabcolname, "/updateone", serviceOfTabColName.UpdateOne)
		// TabColName修改多条
		// RegisterUpdateTabColName(tabcolname, "/update", serviceOfTabColName.Update)

		// CodeParser的路由组
		codeparser := party.Party("/codeparser")
		// CodeParser的服务实例
		var serviceOfCodeParser = svr.NewCodeParserService()
		// CodeParser插入一条
		// RegisterInsertOneCodeParser(codeparser, "/insertone", serviceOfCodeParser.InsertOne)
		// CodeParser插入多条
		// RegisterInsertCodeParser(codeparser, "/insert", serviceOfCodeParser.Insert)
		// CodeParser删除一条
		// RegisterDeleteOneCodeParser(codeparser, "/deleteone", serviceOfCodeParser.DeleteOne)
		// CodeParser删除多条
		// RegisterDeleteCodeParser(codeparser, "/delete", serviceOfCodeParser.Delete)
		// CodeParser查询多条
		RegisterSelectCodeParser(codeparser, "/query", serviceOfCodeParser.Select)
		// CodeParser查询一条
		RegisterSelectOneCodeParser(codeparser, "/get", serviceOfCodeParser.SelectOne)
		// CodeParser修改一条
		// RegisterUpdateOneCodeParser(codeparser, "/updateone", serviceOfCodeParser.UpdateOne)
		// CodeParser修改多条
		// RegisterUpdateCodeParser(codeparser, "/update", serviceOfCodeParser.Update)

	// LabelDetail的路由组
		labeldetail := party.Party("/labeldetail")
		// LabelDetail的服务实例
		var serviceOfLabelDetail = svr.NewLabelDetailService()
		// LabelDetail插入一条
		// RegisterInsertOneLabelDetail(labeldetail, "/insertone", serviceOfLabelDetail.InsertOne)
		// LabelDetail插入多条
		// RegisterInsertLabelDetail(labeldetail, "/insert", serviceOfLabelDetail.Insert)
		// LabelDetail删除一条
		// RegisterDeleteOneLabelDetail(labeldetail, "/deleteone", serviceOfLabelDetail.DeleteOne)
		// LabelDetail删除多条
		// RegisterDeleteLabelDetail(labeldetail, "/delete", serviceOfLabelDetail.Delete)
		// LabelDetail查询多条
		RegisterSelectLabelDetail(labeldetail, "/query", serviceOfLabelDetail.Select)
		// LabelDetail查询一条
		RegisterSelectOneLabelDetail(labeldetail, "/get", serviceOfLabelDetail.SelectOne)
		// LabelDetail修改一条
		// RegisterUpdateOneLabelDetail(labeldetail, "/updateone", serviceOfLabelDetail.UpdateOne)
		// LabelDetail修改多条
		// RegisterUpdateLabelDetail(labeldetail, "/update", serviceOfLabelDetail.Update)

		// LabelHead的路由组
		labelhead := party.Party("/labelhead")
		// LabelHead的服务实例
		var serviceOfLabelHead = svr.NewLabelHeadService()
		// LabelHead插入一条
		RegisterInsertOneLabelHead(labelhead, "/insertone", serviceOfLabelHead.InsertOne)
		// LabelHead插入多条
		// RegisterInsertLabelHead(labelhead, "/insert", serviceOfLabelHead.Insert)
		// LabelHead删除一条
		RegisterDeleteOneLabelHead(labelhead, "/deleteone", serviceOfLabelHead.DeleteOne)
		// LabelHead删除多条
		// RegisterDeleteLabelHead(labelhead, "/delete", serviceOfLabelHead.Delete)
		// LabelHead查询多条
		RegisterSelectLabelHead(labelhead, "/query", serviceOfLabelHead.Select)
		// LabelHead查询一条
		RegisterSelectOneLabelHead(labelhead, "/get", serviceOfLabelHead.SelectOne)
		// LabelHead修改一条
		RegisterUpdateOneLabelHead(labelhead, "/updateone", serviceOfLabelHead.UpdateOne)
		// LabelHead修改多条
		// RegisterUpdateLabelHead(labelhead, "/update", serviceOfLabelHead.Update)

		// LabelTemplateDetail的路由组
		labeltemplatedetail := party.Party("/labeltemplatedetail")
		// LabelTemplateDetail的服务实例
		var serviceOfLabelTemplateDetail = svr.NewLabelTemplateDetailService()
		// LabelTemplateDetail插入一条
		// RegisterInsertOneLabelTemplateDetail(labeltemplatedetail, "/insertone", serviceOfLabelTemplateDetail.InsertOne)
		// LabelTemplateDetail插入多条
		// RegisterInsertLabelTemplateDetail(labeltemplatedetail, "/insert", serviceOfLabelTemplateDetail.Insert)
		// LabelTemplateDetail删除一条
		// RegisterDeleteOneLabelTemplateDetail(labeltemplatedetail, "/deleteone", serviceOfLabelTemplateDetail.DeleteOne)
		// LabelTemplateDetail删除多条
		// RegisterDeleteLabelTemplateDetail(labeltemplatedetail, "/delete", serviceOfLabelTemplateDetail.Delete)
		// LabelTemplateDetail查询多条
		RegisterSelectLabelTemplateDetail(labeltemplatedetail, "/query", serviceOfLabelTemplateDetail.Select)
		// LabelTemplateDetail查询一条
		RegisterSelectOneLabelTemplateDetail(labeltemplatedetail, "/get", serviceOfLabelTemplateDetail.SelectOne)
		// LabelTemplateDetail修改一条
		// RegisterUpdateOneLabelTemplateDetail(labeltemplatedetail, "/updateone", serviceOfLabelTemplateDetail.UpdateOne)
		// LabelTemplateDetail修改多条
		// RegisterUpdateLabelTemplateDetail(labeltemplatedetail, "/update", serviceOfLabelTemplateDetail.Update)

		// LabelTemplateHead的路由组
		labeltemplatehead := party.Party("/labeltemplatehead")
		// LabelTemplateHead的服务实例
		var serviceOfLabelTemplateHead = svr.NewLabelTemplateHeadService()
		// LabelTemplateHead插入一条
		RegisterInsertOneLabelTemplateHead(labeltemplatehead, "/insertone", serviceOfLabelTemplateHead.InsertOne)
		// LabelTemplateHead插入多条
		// RegisterInsertLabelTemplateHead(labeltemplatehead, "/insert", serviceOfLabelTemplateHead.Insert)
		// LabelTemplateHead删除一条
		RegisterDeleteOneLabelTemplateHead(labeltemplatehead, "/deleteone", serviceOfLabelTemplateHead.DeleteOne)
		// LabelTemplateHead删除多条
		// RegisterDeleteLabelTemplateHead(labeltemplatehead, "/delete", serviceOfLabelTemplateHead.Delete)
		// LabelTemplateHead查询多条
		RegisterSelectLabelTemplateHead(labeltemplatehead, "/query", serviceOfLabelTemplateHead.Select)
		// LabelTemplateHead查询一条
		RegisterSelectOneLabelTemplateHead(labeltemplatehead, "/get", serviceOfLabelTemplateHead.SelectOne)
		// LabelTemplateHead修改一条
		RegisterUpdateOneLabelTemplateHead(labeltemplatehead, "/updateone", serviceOfLabelTemplateHead.UpdateOne)
		// LabelTemplateHead修改多条
		// RegisterUpdateLabelTemplateHead(labeltemplatehead, "/update", serviceOfLabelTemplateHead.Update)

		// Printer的路由组
		printer := party.Party("/printer")
		// Printer的服务实例
		var serviceOfPrinter = svr.NewPrinterService()
		// Printer插入一条
		RegisterInsertOnePrinter(printer, "/insertone", serviceOfPrinter.InsertOne)
		// Printer插入多条
		// RegisterInsertPrinter(printer, "/insert", serviceOfPrinter.Insert)
		// Printer删除一条
		RegisterDeleteOnePrinter(printer, "/deleteone", serviceOfPrinter.DeleteOne)
		// Printer删除多条
		// RegisterDeletePrinter(printer, "/delete", serviceOfPrinter.Delete)
		// Printer查询多条
		RegisterSelectPrinter(printer, "/query", serviceOfPrinter.Select)
		// Printer查询一条
		RegisterSelectOnePrinter(printer, "/get", serviceOfPrinter.SelectOne)
		// Printer修改一条
		RegisterUpdateOnePrinter(printer, "/updateone", serviceOfPrinter.UpdateOne)
		// Printer修改多条
		// RegisterUpdatePrinter(printer, "/update", serviceOfPrinter.Update)

		// ReceiptDetail的路由组
		receiptdetail := party.Party("/receiptdetail")
		// ReceiptDetail的服务实例
		var serviceOfReceiptDetail = svr.NewReceiptDetailService()
		// ReceiptDetail插入一条
		// RegisterInsertOneReceiptDetail(receiptdetail, "/insertone", serviceOfReceiptDetail.InsertOne)
		// ReceiptDetail插入多条
		// RegisterInsertReceiptDetail(receiptdetail, "/insert", serviceOfReceiptDetail.Insert)
		// ReceiptDetail删除一条
		// RegisterDeleteOneReceiptDetail(receiptdetail, "/deleteone", serviceOfReceiptDetail.DeleteOne)
		// ReceiptDetail删除多条
		// RegisterDeleteReceiptDetail(receiptdetail, "/delete", serviceOfReceiptDetail.Delete)
		// ReceiptDetail查询多条
		RegisterSelectReceiptDetail(receiptdetail, "/query", serviceOfReceiptDetail.Select)
		// ReceiptDetail查询一条
		RegisterSelectOneReceiptDetail(receiptdetail, "/get", serviceOfReceiptDetail.SelectOne)
		// ReceiptDetail修改一条
		// RegisterUpdateOneReceiptDetail(receiptdetail, "/updateone", serviceOfReceiptDetail.UpdateOne)
		// ReceiptDetail修改多条
		// RegisterUpdateReceiptDetail(receiptdetail, "/update", serviceOfReceiptDetail.Update)

		// ReceiptHead的路由组
		receipthead := party.Party("/receipthead")
		// ReceiptHead的服务实例
		var serviceOfReceiptHead = svr.NewReceiptHeadService()
		// ReceiptHead插入一条
		RegisterInsertOneReceiptHead(receipthead, "/insertone", serviceOfReceiptHead.InsertOne)
		// ReceiptHead插入多条
		// RegisterInsertReceiptHead(receipthead, "/insert", serviceOfReceiptHead.Insert)
		// ReceiptHead删除一条
		RegisterDeleteOneReceiptHead(receipthead, "/deleteone", serviceOfReceiptHead.DeleteOne)
		// ReceiptHead删除多条
		// RegisterDeleteReceiptHead(receipthead, "/delete", serviceOfReceiptHead.Delete)
		// ReceiptHead查询多条
		RegisterSelectReceiptHead(receipthead, "/query", serviceOfReceiptHead.Select)
		// ReceiptHead查询一条
		RegisterSelectOneReceiptHead(receipthead, "/get", serviceOfReceiptHead.SelectOne)
		// ReceiptHead修改一条
		RegisterUpdateOneReceiptHead(receipthead, "/updateone", serviceOfReceiptHead.UpdateOne)
		// ReceiptHead修改多条
		// RegisterUpdateReceiptHead(receipthead, "/update", serviceOfReceiptHead.Update)

		// ScriptItem的路由组
		scriptitem := party.Party("/scriptitem")
		// ScriptItem的服务实例
		var serviceOfScriptItem = svr.NewScriptItemService()
		// ScriptItem插入一条
		// RegisterInsertOneScriptItem(scriptitem, "/insertone", serviceOfScriptItem.InsertOne)
		// ScriptItem插入多条
		// RegisterInsertScriptItem(scriptitem, "/insert", serviceOfScriptItem.Insert)
		// ScriptItem删除一条
		// RegisterDeleteOneScriptItem(scriptitem, "/deleteone", serviceOfScriptItem.DeleteOne)
		// ScriptItem删除多条
		// RegisterDeleteScriptItem(scriptitem, "/delete", serviceOfScriptItem.Delete)
		// ScriptItem查询多条
		RegisterSelectScriptItem(scriptitem, "/query", serviceOfScriptItem.Select)
		// ScriptItem查询一条
		RegisterSelectOneScriptItem(scriptitem, "/get", serviceOfScriptItem.SelectOne)
		// ScriptItem修改一条
		// RegisterUpdateOneScriptItem(scriptitem, "/updateone", serviceOfScriptItem.UpdateOne)
		// ScriptItem修改多条
		// RegisterUpdateScriptItem(scriptitem, "/update", serviceOfScriptItem.Update)

		// Script的路由组
		script := party.Party("/script")
		// Script的服务实例
		var serviceOfScript = svr.NewScriptService()
		// Script插入一条
		// RegisterInsertOneScript(script, "/insertone", serviceOfScript.InsertOne)
		// Script插入多条
		// RegisterInsertScript(script, "/insert", serviceOfScript.Insert)
		// Script删除一条
		// RegisterDeleteOneScript(script, "/deleteone", serviceOfScript.DeleteOne)
		// Script删除多条
		// RegisterDeleteScript(script, "/delete", serviceOfScript.Delete)
		// Script查询多条
		RegisterSelectScript(script, "/query", serviceOfScript.Select)
		// Script查询一条
		RegisterSelectOneScript(script, "/get", serviceOfScript.SelectOne)
		// Script修改一条
		// RegisterUpdateOneScript(script, "/updateone", serviceOfScript.UpdateOne)
		// Script修改多条
		// RegisterUpdateScript(script, "/update", serviceOfScript.Update)

		// Snr的路由组
		snr := party.Party("/snr")
		// Snr的服务实例
		var serviceOfSnr = svr.NewSnrService()
		// Snr插入一条
		// RegisterInsertOneSnr(snr, "/insertone", serviceOfSnr.InsertOne)
		// Snr插入多条
		// RegisterInsertSnr(snr, "/insert", serviceOfSnr.Insert)
		// Snr删除一条
		// RegisterDeleteOneSnr(snr, "/deleteone", serviceOfSnr.DeleteOne)
		// Snr删除多条
		// RegisterDeleteSnr(snr, "/delete", serviceOfSnr.Delete)
		// Snr查询多条
		RegisterSelectSnr(snr, "/query", serviceOfSnr.Select)
		// Snr查询一条
		RegisterSelectOneSnr(snr, "/get", serviceOfSnr.SelectOne)
		// Snr修改一条
		// RegisterUpdateOneSnr(snr, "/updateone", serviceOfSnr.UpdateOne)
		// Snr修改多条
		// RegisterUpdateSnr(snr, "/update", serviceOfSnr.Update)

		// User的路由组
		user := party.Party("/user")
		// User的服务实例
		var serviceOfUser = svr.NewUserService()
		// User插入一条
		// RegisterInsertOneUser(user, "/insertone", serviceOfUser.InsertOne)
		// User插入多条
		// RegisterInsertUser(user, "/insert", serviceOfUser.Insert)
		// User删除一条
		// RegisterDeleteOneUser(user, "/deleteone", serviceOfUser.DeleteOne)
		// User删除多条
		// RegisterDeleteUser(user, "/delete", serviceOfUser.Delete)
		// User查询多条
		RegisterSelectUser(user, "/query", serviceOfUser.Select)
		// User查询一条
		RegisterSelectOneUser(user, "/get", serviceOfUser.SelectOne)
		// User修改一条
		// RegisterUpdateOneUser(user, "/updateone", serviceOfUser.UpdateOne)
		// User修改多条
		// RegisterUpdateUser(user, "/update", serviceOfUser.Update)

		// Plant的路由组
		plant := party.Party("/plant")
		// Plant的服务实例
		var serviceOfPlant = svr.NewPlantService()
		// Plant插入一条
		// RegisterInsertOnePlant(plant, "/insertone", serviceOfPlant.InsertOne)
		// Plant插入多条
		// RegisterInsertPlant(plant, "/insert", serviceOfPlant.Insert)
		// Plant删除一条
		// RegisterDeleteOnePlant(plant, "/deleteone", serviceOfPlant.DeleteOne)
		// Plant删除多条
		// RegisterDeletePlant(plant, "/delete", serviceOfPlant.Delete)
		// Plant查询多条
		RegisterSelectPlant(plant, "/query", serviceOfPlant.Select)
		// Plant查询一条
		RegisterSelectOnePlant(plant, "/get", serviceOfPlant.SelectOne)
		// Plant修改一条
		// RegisterUpdateOnePlant(plant, "/updateone", serviceOfPlant.UpdateOne)
		// Plant修改多条
		// RegisterUpdatePlant(plant, "/update", serviceOfPlant.Update)

		// Uom的路由组
		uom := party.Party("/uom")
		// Uom的服务实例
		var serviceOfUom = svr.NewUomService()
		// Uom插入一条
		RegisterInsertOneUom(uom, "/insertone", serviceOfUom.InsertOne)
		// Uom插入多条
		// RegisterInsertUom(uom, "/insert", serviceOfUom.Insert)
		// Uom删除一条
		RegisterDeleteOneUom(uom, "/deleteone", serviceOfUom.DeleteOne)
		// Uom删除多条
		// RegisterDeleteUom(uom, "/delete", serviceOfUom.Delete)
		// Uom查询多条
		RegisterSelectUom(uom, "/query", serviceOfUom.Select)
		// Uom查询一条
		RegisterSelectOneUom(uom, "/get", serviceOfUom.SelectOne)
		// Uom修改一条
		RegisterUpdateOneUom(uom, "/updateone", serviceOfUom.UpdateOne)
		// Uom修改多条
		// RegisterUpdateUom(uom, "/update", serviceOfUom.Update)

		// CostCenter的路由组
		costcenter := party.Party("/costcenter")
		// CostCenter的服务实例
		var serviceOfCostCenter = svr.NewCostCenterService()
		// CostCenter插入一条
		RegisterInsertOneCostCenter(costcenter, "/insertone", serviceOfCostCenter.InsertOne)
		// CostCenter插入多条
		// RegisterInsertCostCenter(costcenter, "/insert", serviceOfCostCenter.Insert)
		// CostCenter删除一条
		RegisterDeleteOneCostCenter(costcenter, "/deleteone", serviceOfCostCenter.DeleteOne)
		// CostCenter删除多条
		// RegisterDeleteCostCenter(costcenter, "/delete", serviceOfCostCenter.Delete)
		// CostCenter查询多条
		RegisterSelectCostCenter(costcenter, "/query", serviceOfCostCenter.Select)
		// CostCenter查询一条
		RegisterSelectOneCostCenter(costcenter, "/get", serviceOfCostCenter.SelectOne)
		// CostCenter修改一条
		RegisterUpdateOneCostCenter(costcenter, "/updateone", serviceOfCostCenter.UpdateOne)
		// CostCenter修改多条
		// RegisterUpdateCostCenter(costcenter, "/update", serviceOfCostCenter.Update)

		// StatusColor的路由组
		statuscolor := party.Party("/statuscolor")
		// StatusColor的服务实例
		var serviceOfStatusColor = svr.NewStatusColorService()
		// StatusColor插入一条
		RegisterInsertOneStatusColor(statuscolor, "/insertone", serviceOfStatusColor.InsertOne)
		// StatusColor插入多条
		// RegisterInsertStatusColor(statuscolor, "/insert", serviceOfStatusColor.Insert)
		// StatusColor删除一条
		RegisterDeleteOneStatusColor(statuscolor, "/deleteone", serviceOfStatusColor.DeleteOne)
		// StatusColor删除多条
		// RegisterDeleteStatusColor(statuscolor, "/delete", serviceOfStatusColor.Delete)
		// StatusColor查询多条
		RegisterSelectStatusColor(statuscolor, "/query", serviceOfStatusColor.Select)
		// StatusColor查询一条
		RegisterSelectOneStatusColor(statuscolor, "/get", serviceOfStatusColor.SelectOne)
		// StatusColor修改一条
		RegisterUpdateOneStatusColor(statuscolor, "/updateone", serviceOfStatusColor.UpdateOne)
		// StatusColor修改多条
		// RegisterUpdateStatusColor(statuscolor, "/update", serviceOfStatusColor.Update)

		// Attribute的路由组
		attribute := party.Party("/attribute")
		// Attribute的服务实例
		var serviceOfAttribute = svr.NewAttributeService()
		// Attribute插入一条
		RegisterInsertOneAttribute(attribute, "/insertone", serviceOfAttribute.InsertOne)
		// Attribute插入多条
		// RegisterInsertAttribute(attribute, "/insert", serviceOfAttribute.Insert)
		// Attribute删除一条
		RegisterDeleteOneAttribute(attribute, "/deleteone", serviceOfAttribute.DeleteOne)
		// Attribute删除多条
		// RegisterDeleteAttribute(attribute, "/delete", serviceOfAttribute.Delete)
		// Attribute查询多条
		RegisterSelectAttribute(attribute, "/query", serviceOfAttribute.Select)
		// Attribute查询一条
		RegisterSelectOneAttribute(attribute, "/get", serviceOfAttribute.SelectOne)
		// Attribute修改一条
		RegisterUpdateOneAttribute(attribute, "/updateone", serviceOfAttribute.UpdateOne)
		// Attribute修改多条
		// RegisterUpdateAttribute(attribute, "/update", serviceOfAttribute.Update)

		// AttributeValst的路由组
		attributevalst := party.Party("/attributevalst")
		// AttributeValst的服务实例
		var serviceOfAttributeValst = svr.NewAttributeValstService()
		// AttributeValst插入一条
		// RegisterInsertOneAttributeValst(attributevalst, "/insertone", serviceOfAttributeValst.InsertOne)
		// AttributeValst插入多条
		// RegisterInsertAttributeValst(attributevalst, "/insert", serviceOfAttributeValst.Insert)
		// AttributeValst删除一条
		// RegisterDeleteOneAttributeValst(attributevalst, "/deleteone", serviceOfAttributeValst.DeleteOne)
		// AttributeValst删除多条
		// RegisterDeleteAttributeValst(attributevalst, "/delete", serviceOfAttributeValst.Delete)
		// AttributeValst查询多条
		RegisterSelectAttributeValst(attributevalst, "/query", serviceOfAttributeValst.Select)
		// AttributeValst查询一条
		RegisterSelectOneAttributeValst(attributevalst, "/get", serviceOfAttributeValst.SelectOne)
		// AttributeValst修改一条
		// RegisterUpdateOneAttributeValst(attributevalst, "/updateone", serviceOfAttributeValst.UpdateOne)
		// AttributeValst修改多条
		// RegisterUpdateAttributeValst(attributevalst, "/update", serviceOfAttributeValst.Update)

		// AttributeGroup的路由组
		attributegroup := party.Party("/attributegroup")
		// AttributeGroup的服务实例
		var serviceOfAttributeGroup = svr.NewAttributeGroupService()
		// AttributeGroup插入一条
		RegisterInsertOneAttributeGroup(attributegroup, "/insertone", serviceOfAttributeGroup.InsertOne)
		// AttributeGroup插入多条
		// RegisterInsertAttributeGroup(attributegroup, "/insert", serviceOfAttributeGroup.Insert)
		// AttributeGroup删除一条
		RegisterDeleteOneAttributeGroup(attributegroup, "/deleteone", serviceOfAttributeGroup.DeleteOne)
		// AttributeGroup删除多条
		// RegisterDeleteAttributeGroup(attributegroup, "/delete", serviceOfAttributeGroup.Delete)
		// AttributeGroup查询多条
		RegisterSelectAttributeGroup(attributegroup, "/query", serviceOfAttributeGroup.Select)
		// AttributeGroup查询一条
		RegisterSelectOneAttributeGroup(attributegroup, "/get", serviceOfAttributeGroup.SelectOne)
		// AttributeGroup修改一条
		RegisterUpdateOneAttributeGroup(attributegroup, "/updateone", serviceOfAttributeGroup.UpdateOne)
		// AttributeGroup修改多条
		// RegisterUpdateAttributeGroup(attributegroup, "/update", serviceOfAttributeGroup.Update)

		// AttributeGroupValst的路由组
		attributegroupvalst := party.Party("/attributegroupvalst")
		// AttributeGroupValst的服务实例
		var serviceOfAttributeGroupValst = svr.NewAttributeGroupValstService()
		// AttributeGroupValst插入一条
		// RegisterInsertOneAttributeGroupValst(attributegroupvalst, "/insertone", serviceOfAttributeGroupValst.InsertOne)
		// AttributeGroupValst插入多条
		// RegisterInsertAttributeGroupValst(attributegroupvalst, "/insert", serviceOfAttributeGroupValst.Insert)
		// AttributeGroupValst删除一条
		// RegisterDeleteOneAttributeGroupValst(attributegroupvalst, "/deleteone", serviceOfAttributeGroupValst.DeleteOne)
		// AttributeGroupValst删除多条
		// RegisterDeleteAttributeGroupValst(attributegroupvalst, "/delete", serviceOfAttributeGroupValst.Delete)
		// AttributeGroupValst查询多条
		RegisterSelectAttributeGroupValst(attributegroupvalst, "/query", serviceOfAttributeGroupValst.Select)
		// AttributeGroupValst查询一条
		RegisterSelectOneAttributeGroupValst(attributegroupvalst, "/get", serviceOfAttributeGroupValst.SelectOne)
		// AttributeGroupValst修改一条
		// RegisterUpdateOneAttributeGroupValst(attributegroupvalst, "/updateone", serviceOfAttributeGroupValst.UpdateOne)
		// AttributeGroupValst修改多条
		// RegisterUpdateAttributeGroupValst(attributegroupvalst, "/update", serviceOfAttributeGroupValst.Update)

		// WorkShift的路由组
		workshift := party.Party("/workshift")
		// WorkShift的服务实例
		var serviceOfWorkShift = svr.NewWorkShiftService()
		// WorkShift插入一条
		RegisterInsertOneWorkShift(workshift, "/insertone", serviceOfWorkShift.InsertOne)
		// WorkShift插入多条
		// RegisterInsertWorkShift(workshift, "/insert", serviceOfWorkShift.Insert)
		// WorkShift删除一条
		RegisterDeleteOneWorkShift(workshift, "/deleteone", serviceOfWorkShift.DeleteOne)
		// WorkShift删除多条
		// RegisterDeleteWorkShift(workshift, "/delete", serviceOfWorkShift.Delete)
		// WorkShift查询多条
		RegisterSelectWorkShift(workshift, "/query", serviceOfWorkShift.Select)
		// WorkShift查询一条
		RegisterSelectOneWorkShift(workshift, "/get", serviceOfWorkShift.SelectOne)
		// WorkShift修改一条
		RegisterUpdateOneWorkShift(workshift, "/updateone", serviceOfWorkShift.UpdateOne)
		// WorkShift修改多条
		// RegisterUpdateWorkShift(workshift, "/update", serviceOfWorkShift.Update)

		// WorkShiftEffLst的路由组
		workshiftefflst := party.Party("/workshiftefflst")
		// WorkShiftEffLst的服务实例
		var serviceOfWorkShiftEffLst = svr.NewWorkShiftEffLstService()
		// WorkShiftEffLst插入一条
		RegisterInsertOneWorkShiftEffLst(workshiftefflst, "/insertone", serviceOfWorkShiftEffLst.InsertOne)
		// WorkShiftEffLst插入多条
		// RegisterInsertWorkShiftEffLst(workshiftefflst, "/insert", serviceOfWorkShiftEffLst.Insert)
		// WorkShiftEffLst删除一条
		RegisterDeleteOneWorkShiftEffLst(workshiftefflst, "/deleteone", serviceOfWorkShiftEffLst.DeleteOne)
		// WorkShiftEffLst删除多条
		// RegisterDeleteWorkShiftEffLst(workshiftefflst, "/delete", serviceOfWorkShiftEffLst.Delete)
		// WorkShiftEffLst查询多条
		RegisterSelectWorkShiftEffLst(workshiftefflst, "/query", serviceOfWorkShiftEffLst.Select)
		// WorkShiftEffLst查询一条
		RegisterSelectOneWorkShiftEffLst(workshiftefflst, "/get", serviceOfWorkShiftEffLst.SelectOne)
		// WorkShiftEffLst修改一条
		RegisterUpdateOneWorkShiftEffLst(workshiftefflst, "/updateone", serviceOfWorkShiftEffLst.UpdateOne)
		// WorkShiftEffLst修改多条
		// RegisterUpdateWorkShiftEffLst(workshiftefflst, "/update", serviceOfWorkShiftEffLst.Update)

		// DayModel的路由组
		daymodel := party.Party("/daymodel")
		// DayModel的服务实例
		var serviceOfDayModel = svr.NewDayModelService()
		// DayModel插入一条
		RegisterInsertOneDayModel(daymodel, "/insertone", serviceOfDayModel.InsertOne)
		// DayModel插入多条
		// RegisterInsertDayModel(daymodel, "/insert", serviceOfDayModel.Insert)
		// DayModel删除一条
		RegisterDeleteOneDayModel(daymodel, "/deleteone", serviceOfDayModel.DeleteOne)
		// DayModel删除多条
		// RegisterDeleteDayModel(daymodel, "/delete", serviceOfDayModel.Delete)
		// DayModel查询多条
		RegisterSelectDayModel(daymodel, "/query", serviceOfDayModel.Select)
		// DayModel查询一条
		RegisterSelectOneDayModel(daymodel, "/get", serviceOfDayModel.SelectOne)
		// DayModel修改一条
		RegisterUpdateOneDayModel(daymodel, "/updateone", serviceOfDayModel.UpdateOne)
		// DayModel修改多条
		// RegisterUpdateDayModel(daymodel, "/update", serviceOfDayModel.Update)

		// WeekModel的路由组
		weekmodel := party.Party("/weekmodel")
		// WeekModel的服务实例
		var serviceOfWeekModel = svr.NewWeekModelService()
		// WeekModel插入一条
		RegisterInsertOneWeekModel(weekmodel, "/insertone", serviceOfWeekModel.InsertOne)
		// WeekModel插入多条
		// RegisterInsertWeekModel(weekmodel, "/insert", serviceOfWeekModel.Insert)
		// WeekModel删除一条
		RegisterDeleteOneWeekModel(weekmodel, "/deleteone", serviceOfWeekModel.DeleteOne)
		// WeekModel删除多条
		// RegisterDeleteWeekModel(weekmodel, "/delete", serviceOfWeekModel.Delete)
		// WeekModel查询多条
		RegisterSelectWeekModel(weekmodel, "/query", serviceOfWeekModel.Select)
		// WeekModel查询一条
		RegisterSelectOneWeekModel(weekmodel, "/get", serviceOfWeekModel.SelectOne)
		// WeekModel修改一条
		RegisterUpdateOneWeekModel(weekmodel, "/updateone", serviceOfWeekModel.UpdateOne)
		// WeekModel修改多条
		// RegisterUpdateWeekModel(weekmodel, "/update", serviceOfWeekModel.Update)

		// WeekModelLst的路由组
		weekmodellst := party.Party("/weekmodellst")
		// WeekModelLst的服务实例
		var serviceOfWeekModelLst = svr.NewWeekModelLstService()
		// WeekModelLst插入一条
		//RegisterInsertOneWeekModelLst(weekmodellst, "/insertone", serviceOfWeekModelLst.InsertOne)
		// WeekModelLst插入多条
		RegisterInsertWeekModelLst(weekmodellst, "/insert", serviceOfWeekModelLst.Insert)
		// WeekModelLst删除一条
		//RegisterDeleteOneWeekModelLst(weekmodellst, "/deleteone", serviceOfWeekModelLst.DeleteOne)
		// WeekModelLst删除多条
		// RegisterDeleteWeekModelLst(weekmodellst, "/delete", serviceOfWeekModelLst.Delete)
		// WeekModelLst查询多条
		//RegisterSelectWeekModelLst(weekmodellst, "/query", serviceOfWeekModelLst.Select)
		// WeekModelLst查询一条
		//RegisterSelectOneWeekModelLst(weekmodellst, "/get", serviceOfWeekModelLst.SelectOne)
		// WeekModelLst修改一条
		//RegisterUpdateOneWeekModelLst(weekmodellst, "/updateone", serviceOfWeekModelLst.UpdateOne)
		// WeekModelLst修改多条
		// RegisterUpdateWeekModelLst(weekmodellst, "/update", serviceOfWeekModelLst.Update)

		// WorkCalendar的路由组
		workcalendar := party.Party("/workcalendar")
		// WorkCalendar的服务实例
		var serviceOfWorkCalendar = svr.NewWorkCalendarService()
		// WorkCalendar插入一条
		RegisterInsertOneWorkCalendar(workcalendar, "/insertone", serviceOfWorkCalendar.InsertOne)
		// WorkCalendar插入多条
		// RegisterInsertWorkCalendar(workcalendar, "/insert", serviceOfWorkCalendar.Insert)
		// WorkCalendar删除一条
		RegisterDeleteOneWorkCalendar(workcalendar, "/deleteone", serviceOfWorkCalendar.DeleteOne)
		// WorkCalendar删除多条
		// RegisterDeleteWorkCalendar(workcalendar, "/delete", serviceOfWorkCalendar.Delete)
		// WorkCalendar查询多条
		RegisterSelectWorkCalendar(workcalendar, "/query", serviceOfWorkCalendar.Select)
		// WorkCalendar查询一条
		RegisterSelectOneWorkCalendar(workcalendar, "/get", serviceOfWorkCalendar.SelectOne)
		// WorkCalendar修改一条
		RegisterUpdateOneWorkCalendar(workcalendar, "/updateone", serviceOfWorkCalendar.UpdateOne)
		// WorkCalendar修改多条
		// RegisterUpdateWorkCalendar(workcalendar, "/update", serviceOfWorkCalendar.Update)

		// WorkCalendarLst的路由组
		workcalendarlst := party.Party("/workcalendarlst")
		// WorkCalendarLst的服务实例
		var serviceOfWorkCalendarLst = svr.NewWorkCalendarLstService()
		// WorkCalendarLst插入一条
		//RegisterInsertOneWorkCalendarLst(workcalendarlst, "/insertone", serviceOfWorkCalendarLst.InsertOne)
		// WorkCalendarLst插入多条
		RegisterInsertWorkCalendarLst(workcalendarlst, "/insert", serviceOfWorkCalendarLst.Insert)
		// WorkCalendarLst删除一条
		//RegisterDeleteOneWorkCalendarLst(workcalendarlst, "/deleteone", serviceOfWorkCalendarLst.DeleteOne)
		// WorkCalendarLst删除多条
		// RegisterDeleteWorkCalendarLst(workcalendarlst, "/delete", serviceOfWorkCalendarLst.Delete)
		// WorkCalendarLst查询多条
		//RegisterSelectWorkCalendarLst(workcalendarlst, "/query", serviceOfWorkCalendarLst.Select)
		// WorkCalendarLst查询一条
		//RegisterSelectOneWorkCalendarLst(workcalendarlst, "/get", serviceOfWorkCalendarLst.SelectOne)
		// WorkCalendarLst修改一条
		//RegisterUpdateOneWorkCalendarLst(workcalendarlst, "/updateone", serviceOfWorkCalendarLst.UpdateOne)
		// WorkCalendarLst修改多条
		// RegisterUpdateWorkCalendarLst(workcalendarlst, "/update", serviceOfWorkCalendarLst.Update)

		// WorkLine的路由组
		workline := party.Party("/workline")
		// WorkLine的服务实例
		var serviceOfWorkLine = svr.NewWorkLineService()
		// WorkLine插入一条
		RegisterInsertOneWorkLine(workline, "/insertone", serviceOfWorkLine.InsertOne)
		// WorkLine插入多条
		// RegisterInsertWorkLine(workline, "/insert", serviceOfWorkLine.Insert)
		// WorkLine删除一条
		RegisterDeleteOneWorkLine(workline, "/deleteone", serviceOfWorkLine.DeleteOne)
		// WorkLine删除多条
		// RegisterDeleteWorkLine(workline, "/delete", serviceOfWorkLine.Delete)
		// WorkLine查询多条
		RegisterSelectWorkLine(workline, "/query", serviceOfWorkLine.Select)
		// WorkLine查询一条
		RegisterSelectOneWorkLine(workline, "/get", serviceOfWorkLine.SelectOne)
		// WorkLine修改一条
		RegisterUpdateOneWorkLine(workline, "/updateone", serviceOfWorkLine.UpdateOne)
		// WorkLine修改多条
		// RegisterUpdateWorkLine(workline, "/update", serviceOfWorkLine.Update)
		// WorkLine查询所有
		RegisterSelectJoinWorkPlace(workline, "/selectall", serviceOfWorkLine.SelectJoinWorkPlace)
		// WorkLine查询树状图
		RegisterSelectWorkLineArr(workline, "/worklinetree", serviceOfWorkLine.WorkLineTree)
		// WorkLine产线调度自动排程
		RegisterSelectWorkLineScheduler(workline, "/worklinescheduler", serviceOfWorkLine.WorkLineScheduler)
		// WorkLine产线人工调度排程
		RegisterSelectWorkLineSchedulerManPower(workline, "/manpowerscheduler", serviceOfWorkLine.WorkLineSchedulerManPower)
		//手动左右移动调度
		RegisterWorkLineSchedulerManualr(workline, "/manualrscheduler", serviceOfWorkLine.WorkLineSchedulerManualr)
		//修复产线
		RegisterWorkLineRepairSchedule(workline, "/repairschedule", serviceOfWorkLine.WorkLineRepairSchedule)
		// 保存调度结果
		RegisterSaveWorkLineScheduler(workline, "/savescheduler", serviceOfWorkLine.SaveWorkLineScheduler)

		// WorkLineSpecialDay的路由组
		worklinespecialday := party.Party("/worklinespecialday")
		// WorkLineSpecialDay的服务实例
		var serviceOfWorkLineSpecialDay = svr.NewWorkLineSpecialDayService()
		// WorkLineSpecialDay插入一条
		RegisterInsertOneWorkLineSpecialDay(worklinespecialday, "/insertone", serviceOfWorkLineSpecialDay.InsertOne)
		// WorkLineSpecialDay插入多条
		// RegisterInsertWorkLineSpecialDay(worklinespecialday, "/insert", serviceOfWorkLineSpecialDay.Insert)
		// WorkLineSpecialDay删除一条
		RegisterDeleteOneWorkLineSpecialDay(worklinespecialday, "/deleteone", serviceOfWorkLineSpecialDay.DeleteOne)
		// WorkLineSpecialDay删除多条
		// RegisterDeleteWorkLineSpecialDay(worklinespecialday, "/delete", serviceOfWorkLineSpecialDay.Delete)
		// WorkLineSpecialDay查询多条
		RegisterSelectWorkLineSpecialDay(worklinespecialday, "/query", serviceOfWorkLineSpecialDay.Select)
		// WorkLineSpecialDay查询一条
		RegisterSelectOneWorkLineSpecialDay(worklinespecialday, "/get", serviceOfWorkLineSpecialDay.SelectOne)
		// WorkLineSpecialDay修改一条
		RegisterUpdateOneWorkLineSpecialDay(worklinespecialday, "/updateone", serviceOfWorkLineSpecialDay.UpdateOne)
		// WorkLineSpecialDay修改多条
		// RegisterUpdateWorkLineSpecialDay(worklinespecialday, "/update", serviceOfWorkLineSpecialDay.Update)

		// WorkLineSpecialTime的路由组
		worklinespecialtime := party.Party("/worklinespecialtime")
		// WorkLineSpecialTime的服务实例
		var serviceOfWorkLineSpecialTime = svr.NewWorkLineSpecialTimeService()
		// WorkLineSpecialTime插入一条
		// RegisterInsertOneWorkLineSpecialTime(worklinespecialtime, "/insertone", serviceOfWorkLineSpecialTime.InsertOne)
		// WorkLineSpecialTime插入多条
		// RegisterInsertWorkLineSpecialTime(worklinespecialtime, "/insert", serviceOfWorkLineSpecialTime.Insert)
		// WorkLineSpecialTime删除一条
		// RegisterDeleteOneWorkLineSpecialTime(worklinespecialtime, "/deleteone", serviceOfWorkLineSpecialTime.DeleteOne)
		// WorkLineSpecialTime删除多条
		// RegisterDeleteWorkLineSpecialTime(worklinespecialtime, "/delete", serviceOfWorkLineSpecialTime.Delete)
		// WorkLineSpecialTime查询多条
		RegisterSelectWorkLineSpecialTime(worklinespecialtime, "/query", serviceOfWorkLineSpecialTime.Select)
		// WorkLineSpecialTime查询一条
		RegisterSelectOneWorkLineSpecialTime(worklinespecialtime, "/get", serviceOfWorkLineSpecialTime.SelectOne)
		// WorkLineSpecialTime修改一条
		// RegisterUpdateOneWorkLineSpecialTime(worklinespecialtime, "/updateone", serviceOfWorkLineSpecialTime.UpdateOne)
		// WorkLineSpecialTime修改多条
		// RegisterUpdateWorkLineSpecialTime(worklinespecialtime, "/update", serviceOfWorkLineSpecialTime.Update)

		// Article的路由组
		article := party.Party("/article")
		// Article的服务实例
		var serviceOfArticle = svr.NewArticleService()
		// Article插入一条
		RegisterInsertOneArticle(article, "/insertone", serviceOfArticle.InsertOne)
		// Article插入多条
		// RegisterInsertArticle(article, "/insert", serviceOfArticle.Insert)
		// Article删除一条
		RegisterDeleteOneArticle(article, "/deleteone", serviceOfArticle.DeleteOne)
		// Article删除多条
		// RegisterDeleteArticle(article, "/delete", serviceOfArticle.Delete)
		// Article查询多条
		RegisterSelectArticle(article, "/query", serviceOfArticle.Select)
		// Article查询一条
		RegisterSelectOneArticle(article, "/get", serviceOfArticle.SelectOne)
		// Article修改一条
		RegisterUpdateOneArticle(article, "/updateone", serviceOfArticle.UpdateOne)
		// Article修改多条
		// RegisterUpdateArticle(article, "/update", serviceOfArticle.Update)
		// Article所有所有的car model
		RegisterSelectAllCarModel(article, "/selectallcarmodel", serviceOfArticle.SelectAllCarModel)

		// WorkLineWorkShiftLst的路由组
		worklineworkshiftlst := party.Party("/worklineworkshiftlst")
		// WorkLineWorkShiftLst的服务实例
		var serviceOfWorkLineWorkShiftLst = svr.NewWorkLineWorkShiftLstService()
		// WorkLineWorkShiftLst插入一条
		RegisterInsertOneWorkLineWorkShiftLst(worklineworkshiftlst, "/insertone", serviceOfWorkLineWorkShiftLst.InsertOne)
		// WorkLineWorkShiftLst插入多条
		// RegisterInsertWorkLineWorkShiftLst(worklineworkshiftlst, "/insert", serviceOfWorkLineWorkShiftLst.Insert)
		// WorkLineWorkShiftLst删除一条
		RegisterDeleteOneWorkLineWorkShiftLst(worklineworkshiftlst, "/deleteone", serviceOfWorkLineWorkShiftLst.DeleteOne)
		// WorkLineWorkShiftLst删除多条
		// RegisterDeleteWorkLineWorkShiftLst(worklineworkshiftlst, "/delete", serviceOfWorkLineWorkShiftLst.Delete)
		// WorkLineWorkShiftLst查询多条
		RegisterSelectWorkLineWorkShiftLst(worklineworkshiftlst, "/query", serviceOfWorkLineWorkShiftLst.Select)
		// WorkLineWorkShiftLst查询一条
		RegisterSelectOneWorkLineWorkShiftLst(worklineworkshiftlst, "/get", serviceOfWorkLineWorkShiftLst.SelectOne)
		// WorkLineWorkShiftLst修改一条
		RegisterUpdateOneWorkLineWorkShiftLst(worklineworkshiftlst, "/updateone", serviceOfWorkLineWorkShiftLst.UpdateOne)
		// WorkLineWorkShiftLst修改多条
		// RegisterUpdateWorkLineWorkShiftLst(worklineworkshiftlst, "/update", serviceOfWorkLineWorkShiftLst.Update)

		// WorkLineWorkShiftSpecialTime的路由组
		worklineworkshiftspecialtime := party.Party("/worklineworkshiftspecialtime")
		// WorkLineWorkShiftSpecialTime的服务实例
		var serviceOfWorkLineWorkShiftSpecialTime = svr.NewWorkLineWorkShiftSpecialTimeService()
		// WorkLineWorkShiftSpecialTime插入一条
		// RegisterInsertOneWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/insertone", serviceOfWorkLineWorkShiftSpecialTime.InsertOne)
		// WorkLineWorkShiftSpecialTime插入多条
		// RegisterInsertWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/insert", serviceOfWorkLineWorkShiftSpecialTime.Insert)
		// WorkLineWorkShiftSpecialTime删除一条
		// RegisterDeleteOneWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/deleteone", serviceOfWorkLineWorkShiftSpecialTime.DeleteOne)
		// WorkLineWorkShiftSpecialTime删除多条
		// RegisterDeleteWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/delete", serviceOfWorkLineWorkShiftSpecialTime.Delete)
		// WorkLineWorkShiftSpecialTime查询多条
		RegisterSelectWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/query", serviceOfWorkLineWorkShiftSpecialTime.Select)
		// WorkLineWorkShiftSpecialTime查询一条
		RegisterSelectOneWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/get", serviceOfWorkLineWorkShiftSpecialTime.SelectOne)
		// WorkLineWorkShiftSpecialTime修改一条
		// RegisterUpdateOneWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/updateone", serviceOfWorkLineWorkShiftSpecialTime.UpdateOne)
		// WorkLineWorkShiftSpecialTime修改多条
		// RegisterUpdateWorkLineWorkShiftSpecialTime(worklineworkshiftspecialtime, "/update", serviceOfWorkLineWorkShiftSpecialTime.Update)

		// Person的路由组
		person := party.Party("/person")
		// Person的服务实例
		var serviceOfPerson = svr.NewPersonService()
		// Person插入一条
		RegisterInsertOnePerson(person, "/insertone", serviceOfPerson.InsertOne)
		// Person插入多条
		// RegisterInsertPerson(person, "/insert", serviceOfPerson.Insert)
		// Person删除一条
		RegisterDeleteOnePerson(person, "/deleteone", serviceOfPerson.DeleteOne)
		// Person删除多条
		// RegisterDeletePerson(person, "/delete", serviceOfPerson.Delete)
		// Person查询多条
		RegisterSelectPerson(person, "/query", serviceOfPerson.Select)
		// Person查询一条
		RegisterSelectOnePerson(person, "/get", serviceOfPerson.SelectOne)
		// Person修改一条
		RegisterUpdateOnePerson(person, "/updateone", serviceOfPerson.UpdateOne)
		// Person修改多条
		// RegisterUpdatePerson(person, "/update", serviceOfPerson.Update)
		// Person查询一条
		RegisterSelectCheckLogin(person, "/checklogin", serviceOfPerson.CheckLogin)
		//查询登录信息
		RegisterSelectByUserName(person, "/byusername", serviceOfPerson.SelectOneByUserName)

		// ArticleAtcodLst的路由组
		articleatcodlst := party.Party("/articleatcodlst")
		// ArticleAtcodLst的服务实例
		var serviceOfArticleAtcodLst = svr.NewArticleAtcodLstService()
		// ArticleAtcodLst插入一条
		// RegisterInsertOneArticleAtcodLst(articleatcodlst, "/insertone", serviceOfArticleAtcodLst.InsertOne)
		// ArticleAtcodLst插入多条
		// RegisterInsertArticleAtcodLst(articleatcodlst, "/insert", serviceOfArticleAtcodLst.Insert)
		// ArticleAtcodLst删除一条
		// RegisterDeleteOneArticleAtcodLst(articleatcodlst, "/deleteone", serviceOfArticleAtcodLst.DeleteOne)
		// ArticleAtcodLst删除多条
		// RegisterDeleteArticleAtcodLst(articleatcodlst, "/delete", serviceOfArticleAtcodLst.Delete)
		// ArticleAtcodLst查询多条
		RegisterSelectArticleAtcodLst(articleatcodlst, "/query", serviceOfArticleAtcodLst.Select)
		// ArticleAtcodLst查询一条
		RegisterSelectOneArticleAtcodLst(articleatcodlst, "/get", serviceOfArticleAtcodLst.SelectOne)
		// ArticleAtcodLst修改一条
		// RegisterUpdateOneArticleAtcodLst(articleatcodlst, "/updateone", serviceOfArticleAtcodLst.UpdateOne)
		// ArticleAtcodLst修改多条
		// RegisterUpdateArticleAtcodLst(articleatcodlst, "/update", serviceOfArticleAtcodLst.Update)

		// WorkLineWorkPlaceLst的路由组
		worklineworkplacelst := party.Party("/worklineworkplacelst")
		// WorkLineWorkPlaceLst的服务实例
		var serviceOfWorkLineWorkPlaceLst = svr.NewWorkLineWorkPlaceLstService()
		// WorkLineWorkPlaceLst插入一条
		// RegisterInsertOneWorkLineWorkPlaceLst(worklineworkplacelst, "/insertone", serviceOfWorkLineWorkPlaceLst.InsertOne)
		// WorkLineWorkPlaceLst插入多条
		// RegisterInsertWorkLineWorkPlaceLst(worklineworkplacelst, "/insert", serviceOfWorkLineWorkPlaceLst.Insert)
		// WorkLineWorkPlaceLst删除一条
		// RegisterDeleteOneWorkLineWorkPlaceLst(worklineworkplacelst, "/deleteone", serviceOfWorkLineWorkPlaceLst.DeleteOne)
		// WorkLineWorkPlaceLst删除多条
		// RegisterDeleteWorkLineWorkPlaceLst(worklineworkplacelst, "/delete", serviceOfWorkLineWorkPlaceLst.Delete)
		// WorkLineWorkPlaceLst查询多条
		RegisterSelectWorkLineWorkPlaceLst(worklineworkplacelst, "/query", serviceOfWorkLineWorkPlaceLst.Select)
		// WorkLineWorkPlaceLst查询一条
		RegisterSelectOneWorkLineWorkPlaceLst(worklineworkplacelst, "/get", serviceOfWorkLineWorkPlaceLst.SelectOne)
		// WorkLineWorkPlaceLst修改一条
		// RegisterUpdateOneWorkLineWorkPlaceLst(worklineworkplacelst, "/updateone", serviceOfWorkLineWorkPlaceLst.UpdateOne)
		// WorkLineWorkPlaceLst修改多条
		// RegisterUpdateWorkLineWorkPlaceLst(worklineworkplacelst, "/update", serviceOfWorkLineWorkPlaceLst.Update)

		// WorkPlace的路由组
		workplace := party.Party("/workplace")
		// WorkPlace的服务实例
		var serviceOfWorkPlace = svr.NewWorkPlaceService()
		// WorkPlace插入一条
		RegisterInsertOneWorkPlace(workplace, "/insertone", serviceOfWorkPlace.InsertOne)
		// WorkPlace插入多条
		// RegisterInsertWorkPlace(workplace, "/insert", serviceOfWorkPlace.Insert)
		// WorkPlace删除一条
		RegisterDeleteOneWorkPlace(workplace, "/deleteone", serviceOfWorkPlace.DeleteOne)
		// WorkPlace删除多条
		// RegisterDeleteWorkPlace(workplace, "/delete", serviceOfWorkPlace.Delete)
		// WorkPlace查询多条
		RegisterSelectWorkPlace(workplace, "/query", serviceOfWorkPlace.Select)
		// WorkPlace查询一条
		RegisterSelectOneWorkPlace(workplace, "/get", serviceOfWorkPlace.SelectOne)
		// WorkPlace修改一条
		RegisterUpdateOneWorkPlace(workplace, "/updateone", serviceOfWorkPlace.UpdateOne)
		// WorkPlace修改多条
		// RegisterUpdateWorkPlace(workplace, "/update", serviceOfWorkPlace.Update)

		// WorkPlaceStatus的路由组
		workplacestatus := party.Party("/workplacestatus")
		// WorkPlaceStatus的服务实例
		var serviceOfWorkPlaceStatus = svr.NewWorkPlaceStatusService()
		// WorkPlaceStatus插入一条
		// RegisterInsertOneWorkPlaceStatus(workplacestatus, "/insertone", serviceOfWorkPlaceStatus.InsertOne)
		// WorkPlaceStatus插入多条
		// RegisterInsertWorkPlaceStatus(workplacestatus, "/insert", serviceOfWorkPlaceStatus.Insert)
		// WorkPlaceStatus删除一条
		// RegisterDeleteOneWorkPlaceStatus(workplacestatus, "/deleteone", serviceOfWorkPlaceStatus.DeleteOne)
		// WorkPlaceStatus删除多条
		// RegisterDeleteWorkPlaceStatus(workplacestatus, "/delete", serviceOfWorkPlaceStatus.Delete)
		// WorkPlaceStatus查询多条
		RegisterSelectWorkPlaceStatus(workplacestatus, "/query", serviceOfWorkPlaceStatus.Select)
		// WorkPlaceStatus查询一条
		RegisterSelectOneWorkPlaceStatus(workplacestatus, "/get", serviceOfWorkPlaceStatus.SelectOne)
		// WorkPlaceStatus修改一条
		// RegisterUpdateOneWorkPlaceStatus(workplacestatus, "/updateone", serviceOfWorkPlaceStatus.UpdateOne)
		// WorkPlaceStatus修改多条
		// RegisterUpdateWorkPlaceStatus(workplacestatus, "/update", serviceOfWorkPlaceStatus.Update)

		// WorkPlaceStatusRecLst的路由组
		workplacestatusreclst := party.Party("/workplacestatusreclst")
		// WorkPlaceStatusRecLst的服务实例
		var serviceOfWorkPlaceStatusRecLst = svr.NewWorkPlaceStatusRecLstService()
		// WorkPlaceStatusRecLst插入一条
		// RegisterInsertOneWorkPlaceStatusRecLst(workplacestatusreclst, "/insertone", serviceOfWorkPlaceStatusRecLst.InsertOne)
		// WorkPlaceStatusRecLst插入多条
		// RegisterInsertWorkPlaceStatusRecLst(workplacestatusreclst, "/insert", serviceOfWorkPlaceStatusRecLst.Insert)
		// WorkPlaceStatusRecLst删除一条
		// RegisterDeleteOneWorkPlaceStatusRecLst(workplacestatusreclst, "/deleteone", serviceOfWorkPlaceStatusRecLst.DeleteOne)
		// WorkPlaceStatusRecLst删除多条
		// RegisterDeleteWorkPlaceStatusRecLst(workplacestatusreclst, "/delete", serviceOfWorkPlaceStatusRecLst.Delete)
		// WorkPlaceStatusRecLst查询多条
		RegisterSelectWorkPlaceStatusRecLst(workplacestatusreclst, "/query", serviceOfWorkPlaceStatusRecLst.Select)
		// WorkPlaceStatusRecLst查询一条
		RegisterSelectOneWorkPlaceStatusRecLst(workplacestatusreclst, "/get", serviceOfWorkPlaceStatusRecLst.SelectOne)
		// WorkPlaceStatusRecLst修改一条
		// RegisterUpdateOneWorkPlaceStatusRecLst(workplacestatusreclst, "/updateone", serviceOfWorkPlaceStatusRecLst.UpdateOne)
		// WorkPlaceStatusRecLst修改多条
		// RegisterUpdateWorkPlaceStatusRecLst(workplacestatusreclst, "/update", serviceOfWorkPlaceStatusRecLst.Update)

		// WorkPlacePersonLst的路由组
		workplacepersonlst := party.Party("/workplacepersonlst")
		// WorkPlacePersonLst的服务实例
		var serviceOfWorkPlacePersonLst = svr.NewWorkPlacePersonLstService()
		// WorkPlacePersonLst插入一条
		// RegisterInsertOneWorkPlacePersonLst(workplacepersonlst, "/insertone", serviceOfWorkPlacePersonLst.InsertOne)
		// WorkPlacePersonLst插入多条
		// RegisterInsertWorkPlacePersonLst(workplacepersonlst, "/insert", serviceOfWorkPlacePersonLst.Insert)
		// WorkPlacePersonLst删除一条
		// RegisterDeleteOneWorkPlacePersonLst(workplacepersonlst, "/deleteone", serviceOfWorkPlacePersonLst.DeleteOne)
		// WorkPlacePersonLst删除多条
		// RegisterDeleteWorkPlacePersonLst(workplacepersonlst, "/delete", serviceOfWorkPlacePersonLst.Delete)
		// WorkPlacePersonLst查询多条
		RegisterSelectWorkPlacePersonLst(workplacepersonlst, "/query", serviceOfWorkPlacePersonLst.Select)
		// WorkPlacePersonLst查询一条
		RegisterSelectOneWorkPlacePersonLst(workplacepersonlst, "/get", serviceOfWorkPlacePersonLst.SelectOne)
		// WorkPlacePersonLst修改一条
		// RegisterUpdateOneWorkPlacePersonLst(workplacepersonlst, "/updateone", serviceOfWorkPlacePersonLst.UpdateOne)
		// WorkPlacePersonLst修改多条
		// RegisterUpdateWorkPlacePersonLst(workplacepersonlst, "/update", serviceOfWorkPlacePersonLst.Update)

		// PersonLoginHistory的路由组
		personloginhistory := party.Party("/personloginhistory")
		// PersonLoginHistory的服务实例
		var serviceOfPersonLoginHistory = svr.NewPersonLoginHistoryService()
		// PersonLoginHistory插入一条
		// RegisterInsertOnePersonLoginHistory(personloginhistory, "/insertone", serviceOfPersonLoginHistory.InsertOne)
		// PersonLoginHistory插入多条
		// RegisterInsertPersonLoginHistory(personloginhistory, "/insert", serviceOfPersonLoginHistory.Insert)
		// PersonLoginHistory删除一条
		// RegisterDeleteOnePersonLoginHistory(personloginhistory, "/deleteone", serviceOfPersonLoginHistory.DeleteOne)
		// PersonLoginHistory删除多条
		// RegisterDeletePersonLoginHistory(personloginhistory, "/delete", serviceOfPersonLoginHistory.Delete)
		// PersonLoginHistory查询多条
		RegisterSelectPersonLoginHistory(personloginhistory, "/query", serviceOfPersonLoginHistory.Select)
		// PersonLoginHistory查询一条
		RegisterSelectOnePersonLoginHistory(personloginhistory, "/get", serviceOfPersonLoginHistory.SelectOne)
		// PersonLoginHistory修改一条
		// RegisterUpdateOnePersonLoginHistory(personloginhistory, "/updateone", serviceOfPersonLoginHistory.UpdateOne)
		// PersonLoginHistory修改多条
		// RegisterUpdatePersonLoginHistory(personloginhistory, "/update", serviceOfPersonLoginHistory.Update)

		// ArticleType的路由组
		articletype := party.Party("/articletype")
		// ArticleType的服务实例
		var serviceOfArticleType = svr.NewArticleTypeService()
		// ArticleType插入一条
		// RegisterInsertOneArticleType(articletype, "/insertone", serviceOfArticleType.InsertOne)
		// ArticleType插入多条
		// RegisterInsertArticleType(articletype, "/insert", serviceOfArticleType.Insert)
		// ArticleType删除一条
		// RegisterDeleteOneArticleType(articletype, "/deleteone", serviceOfArticleType.DeleteOne)
		// ArticleType删除多条
		// RegisterDeleteArticleType(articletype, "/delete", serviceOfArticleType.Delete)
		// ArticleType查询多条
		RegisterSelectArticleType(articletype, "/query", serviceOfArticleType.Select)
		// ArticleType查询一条
		RegisterSelectOneArticleType(articletype, "/get", serviceOfArticleType.SelectOne)
		// ArticleType修改一条
		// RegisterUpdateOneArticleType(articletype, "/updateone", serviceOfArticleType.UpdateOne)
		// ArticleType修改多条
		// RegisterUpdateArticleType(articletype, "/update", serviceOfArticleType.Update)

		// LabelParserHead的路由组
		labelparserhead := party.Party("/labelparserhead")
		// LabelParserHead的服务实例
		var serviceOfLabelParserHead = svr.NewLabelParserHeadService()
		// LabelParserHead插入一条
		RegisterInsertOneLabelParserHead(labelparserhead, "/insertone", serviceOfLabelParserHead.InsertOne)
		// LabelParserHead插入多条
		// RegisterInsertLabelParserHead(labelparserhead, "/insert", serviceOfLabelParserHead.Insert)
		// LabelParserHead删除一条
		RegisterDeleteOneLabelParserHead(labelparserhead, "/deleteone", serviceOfLabelParserHead.DeleteOne)
		// LabelParserHead删除多条
		// RegisterDeleteLabelParserHead(labelparserhead, "/delete", serviceOfLabelParserHead.Delete)
		// LabelParserHead查询多条
		RegisterSelectLabelParserHead(labelparserhead, "/query", serviceOfLabelParserHead.Select)
		// LabelParserHead查询一条
		RegisterSelectOneLabelParserHead(labelparserhead, "/get", serviceOfLabelParserHead.SelectOne)
		// LabelParserHead修改一条
		RegisterUpdateOneLabelParserHead(labelparserhead, "/updateone", serviceOfLabelParserHead.UpdateOne)
		// LabelParserHead修改多条
		// RegisterUpdateLabelParserHead(labelparserhead, "/update", serviceOfLabelParserHead.Update)

		// LabelParserDetailLst的路由组
		labelparserdetaillst := party.Party("/labelparserdetaillst")
		// LabelParserDetailLst的服务实例
		var serviceOfLabelParserDetailLst = svr.NewLabelParserDetailLstService()
		// LabelParserDetailLst插入一条
		// RegisterInsertOneLabelParserDetailLst(labelparserdetaillst, "/insertone", serviceOfLabelParserDetailLst.InsertOne)
		// LabelParserDetailLst插入多条
		// RegisterInsertLabelParserDetailLst(labelparserdetaillst, "/insert", serviceOfLabelParserDetailLst.Insert)
		// LabelParserDetailLst删除一条
		// RegisterDeleteOneLabelParserDetailLst(labelparserdetaillst, "/deleteone", serviceOfLabelParserDetailLst.DeleteOne)
		// LabelParserDetailLst删除多条
		// RegisterDeleteLabelParserDetailLst(labelparserdetaillst, "/delete", serviceOfLabelParserDetailLst.Delete)
		// LabelParserDetailLst查询多条
		RegisterSelectLabelParserDetailLst(labelparserdetaillst, "/query", serviceOfLabelParserDetailLst.Select)
		// LabelParserDetailLst查询一条
		RegisterSelectOneLabelParserDetailLst(labelparserdetaillst, "/get", serviceOfLabelParserDetailLst.SelectOne)
		// LabelParserDetailLst修改一条
		// RegisterUpdateOneLabelParserDetailLst(labelparserdetaillst, "/updateone", serviceOfLabelParserDetailLst.UpdateOne)
		// LabelParserDetailLst修改多条
		// RegisterUpdateLabelParserDetailLst(labelparserdetaillst, "/update", serviceOfLabelParserDetailLst.Update)

		// RoleRel的路由组
		rolerel := party.Party("/rolerel")
		// RoleRel的服务实例
		var serviceOfRoleRel = svr.NewRoleRelService()
		// RoleRel插入一条
		// RegisterInsertOneRoleRel(rolerel, "/insertone", serviceOfRoleRel.InsertOne)
		// RoleRel插入多条
		RegisterInsertRoleRel(rolerel, "/insert", serviceOfRoleRel.Insert)
		// RoleRel删除一条
		// RegisterDeleteOneRoleRel(rolerel, "/deleteone", serviceOfRoleRel.DeleteOne)
		// RoleRel删除多条
		// RegisterDeleteRoleRel(rolerel, "/delete", serviceOfRoleRel.Delete)
		// RoleRel查询多条
		RegisterSelectRoleRel(rolerel, "/query", serviceOfRoleRel.Select)
		// RoleRel查询一条
		//RegisterSelectOneRoleRel(rolerel, "/get", serviceOfRoleRel.SelectOne)
		// RoleRel修改一条
		// RegisterUpdateOneRoleRel(rolerel, "/updateone", serviceOfRoleRel.UpdateOne)
		// RoleRel修改多条
		// RegisterUpdateRoleRel(rolerel, "/update", serviceOfRoleRel.Update)
	})
}

/******************************************************************************
 *
 * @Interface Name           : init
 *-----------------------------------------------------------------------------
 *
 * @Description              : 包初始化方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-25 14:20:56
 *
 ******************************************************************************/
func init() {

	// 注册路由
	RegisterRoutes()
}
