// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package jit

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	svr "LAPP_GAAS_GFrame_BACKEND/services/jit"
	"github.com/kataras/iris/v12/core/router"
)

/******************************************************************************
 *
 * @Interface Name           : RegisterRoutes
 *-----------------------------------------------------------------------------
 *
 * @Description              : 注册路由
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
func RegisterRoutes() {
	// 模块jit路由分组
	grmi.RegisterRouteMapping("/jit", func(party router.Party) {

		// ShipOrder的路由组
		shiporder := party.Party("/shiporder")
		// ShipOrder的服务实例
		var serviceOfShipOrder = svr.NewShipOrderService()
		// ShipOrder插入一条
		RegisterInsertOneShipOrder(shiporder, "/insertone", serviceOfShipOrder.InsertOne)
		// ShipOrder插入多条
		// RegisterInsertShipOrder(shiporder, "/insert", serviceOfShipOrder.Insert)
		// ShipOrder删除一条
		RegisterDeleteOneShipOrder(shiporder, "/deleteone", serviceOfShipOrder.DeleteOne)
		// ShipOrder删除多条
		// RegisterDeleteShipOrder(shiporder, "/delete", serviceOfShipOrder.Delete)
		// ShipOrder查询多条
		RegisterSelectShipOrder(shiporder, "/selectlist", serviceOfShipOrder.SelectList)
		// ShipOrder查询多条并分页
		RegisterQueryShipOrder(shiporder, "/query", serviceOfShipOrder.SelectAndPaging)
		// ShipOrder查询一条
		RegisterSelectOneShipOrder(shiporder, "/selectone", serviceOfShipOrder.SelectOne)
		// ShipOrder修改一条
		// RegisterUpdateOneShipOrder(shiporder, "/updateone", serviceOfShipOrder.UpdateOne)
		// ShipOrder修改多条
		// RegisterUpdateShipOrder(shiporder, "/update", serviceOfShipOrder.Update)
		//发运扫描
		RegisterScanCarPackOrders(shiporder, "/scancarpack", serviceOfShipOrder.ScanCarPackOrders)

		// ShipOrderItemlst的路由组
		shiporderitemlst := party.Party("/shiporderitemlst")
		// ShipOrderItemlst的服务实例
		var serviceOfShipOrderItemlst = svr.NewShipOrderItemlstService()
		// ShipOrderItemlst插入一条
		// RegisterInsertOneShipOrderItemlst(shiporderitemlst, "/insertone", serviceOfShipOrderItemlst.InsertOne)
		// ShipOrderItemlst插入多条
		// RegisterInsertShipOrderItemlst(shiporderitemlst, "/insert", serviceOfShipOrderItemlst.Insert)
		// ShipOrderItemlst删除一条
		// RegisterDeleteOneShipOrderItemlst(shiporderitemlst, "/deleteone", serviceOfShipOrderItemlst.DeleteOne)
		// ShipOrderItemlst删除多条
		// RegisterDeleteShipOrderItemlst(shiporderitemlst, "/delete", serviceOfShipOrderItemlst.Delete)
		// ShipOrderItemlst查询多条
		RegisterSelectShipOrderItemlst(shiporderitemlst, "/selectlist", serviceOfShipOrderItemlst.Select)
		// ShipOrderItemlst查询多条并分页
		//RegisterQueryShipOrderItemlst(shiporderitemlst, "/query", serviceOfShipOrderItemlst.SelectAndPaging)
		// ShipOrderItemlst查询一条
		RegisterSelectOneShipOrderItemlst(shiporderitemlst, "/selectone", serviceOfShipOrderItemlst.SelectOne)
		// ShipOrderItemlst修改一条
		// RegisterUpdateOneShipOrderItemlst(shiporderitemlst, "/updateone", serviceOfShipOrderItemlst.UpdateOne)
		// ShipOrderItemlst修改多条
		// RegisterUpdateShipOrderItemlst(shiporderitemlst, "/update", serviceOfShipOrderItemlst.Update)

		// ShipOrderDatalst的路由组
		shiporderdatalst := party.Party("/shiporderdatalst")
		// ShipOrderDatalst的服务实例
		var serviceOfShipOrderDatalst = svr.NewShipOrderDatalstService()
		// ShipOrderDatalst插入一条
		// RegisterInsertOneShipOrderDatalst(shiporderdatalst, "/insertone", serviceOfShipOrderDatalst.InsertOne)
		// ShipOrderDatalst插入多条
		// RegisterInsertShipOrderDatalst(shiporderdatalst, "/insert", serviceOfShipOrderDatalst.Insert)
		// ShipOrderDatalst删除一条
		// RegisterDeleteOneShipOrderDatalst(shiporderdatalst, "/deleteone", serviceOfShipOrderDatalst.DeleteOne)
		// ShipOrderDatalst删除多条
		// RegisterDeleteShipOrderDatalst(shiporderdatalst, "/delete", serviceOfShipOrderDatalst.Delete)
		// ShipOrderDatalst查询多条
		RegisterSelectShipOrderDatalst(shiporderdatalst, "/selectlist", serviceOfShipOrderDatalst.Select)
		// ShipOrderDatalst查询多条并分页
		//RegisterQueryShipOrderDatalst(shiporderdatalst, "/query", serviceOfShipOrderDatalst.SelectAndPaging)
		// ShipOrderDatalst查询一条
		RegisterSelectOneShipOrderDatalst(shiporderdatalst, "/selectone", serviceOfShipOrderDatalst.SelectOne)
		// ShipOrderDatalst修改一条
		// RegisterUpdateOneShipOrderDatalst(shiporderdatalst, "/updateone", serviceOfShipOrderDatalst.UpdateOne)
		// ShipOrderDatalst修改多条
		// RegisterUpdateShipOrderDatalst(shiporderdatalst, "/update", serviceOfShipOrderDatalst.Update)
	})
}

/******************************************************************************
 *
 * @Interface Name           : init
 *-----------------------------------------------------------------------------
 *
 * @Description              : 包初始化方法
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-25 13:36:01
 *
 ******************************************************************************/
func init() {

	// 注册路由
	RegisterRoutes()
}
